/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 #include "affiche_syntaxe.h"

 
 affiche_syntaxe::affiche_syntaxe( QTextEdit * textEdit ) : QSyntaxHighlighter(textEdit) {
 };
 
 int affiche_syntaxe::highlightParagraph(const QString &text, int endStateOfLastPara ) {
 int i,j;
 QString buf;
 
 //paramtres par dfaut
 QFont  font( "TypeWriter", 10); 
 font.setItalic(FALSE);
 QColor color;
 color.setRgb(0,0,0);
 
 int pos=0;               //position dans le texte
 int comment = 0;         //boolen : est-on dans un commentaire ?
 int n = text.length();   //longueur du texte
 
 //rtablissement des font et couleurs par dfaut 
 setFormat (0,n,font,color);
 
 if(endStateOfLastPara>0) {
    i=0;
    j=endStateOfLastPara;
    while(j>0 && pos+i<n) {      
      if(text[pos+i]=='<') j++;
      if(text[pos+i]=='>') j--; 
      i++;
      }
    if(j!=0) comment = j;    
    buf = text;
    buf.truncate(pos+i+1);
    buf.truncate(-i-1);    
    color.setRgb(155,155,155);    
    setFormat (pos,i+1,font,color);
    pos+=i;
    if(pos>=n) return(comment);
 }
 
 //traitement des balises
 font.setItalic(TRUE);
 for(;pos<n;pos++) {
 	if(text[pos]=='<') {
		i=1;
		j=1;
		while(j>0 && pos+i<n) {
		  if(text[pos+i]=='<') j++;
		  if(text[pos+i]=='>') j--; 
		  i++;
		  }
		if(j!=0) comment = j;
		buf = text;
		buf.truncate(pos+i+1);
		buf.truncate(-i-1);
		if(buf.contains("!--")) 
		   color.setRgb(155,155,155); //commentaire en gris
		                              //@todo problme de coloration  des commentaires si sur plusieurs lignes
		else {
		   if(buf.contains("modele")||buf.contains("variable")||buf.contains("parametre")||buf.contains("equation"))    
			color.setRgb(255,0,0);   //balises obligatoires en rouge
		   else
			color.setRgb(50,200,0);  //balises optionnelles en vert
			}
		setFormat (pos,i,font,color);
		pos+=i;
		}
  	} 
 return(comment);
 };
