/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ajout_distribution.h"

#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qtable.h>

ajout_distribution::ajout_distribution(qmodele* xm) : Form_ajout_distribution()
{
QObject::connect(pushButton_ok,SIGNAL(clicked()),this,SLOT(ok()));
QObject::connect(pushButton_annuler,SIGNAL(clicked()),this,SLOT(annuler()));
QObject::connect(comboBox_famille,SIGNAL(activated(int)),this,SLOT(select_famille()));

m = xm;

QStringList list;
for(int i=0;i<m->get_var_nb();i++) list << m->get_var_nom(i);
for(int i=0;i<m->get_par_nb();i++) list << m->get_par_nom(i);
comboBox_var->insertStringList(list);

list = nom_distribution(0); int i = 1;
while(nom_distribution(i)!=NULL) {list << nom_distribution(i); i++;}
comboBox_famille->insertStringList(list);

table_def->setColumnStretchable(0,true);
select_famille();
}

void ajout_distribution::select_famille() {
  char symb = symbole_distribution((char*)(comboBox_famille->currentText().ascii()));
  
  if(get_fonction_construction_distribution((char)symb)==NULL) {
    radioButton_def_parametre->setChecked(true);
    radioButton_def_parametre->setEnabled(true);
    radioButton_def_moment->setEnabled(false);
    }
  else {
    radioButton_def_parametre->setEnabled(true);
    radioButton_def_moment->setEnabled(true);
    }
  int n = nb_arg_max_distribution((char)symb);
  if(n>0) table_def->setNumRows(n);
  else     table_def->setNumRows(6);
  }

QString* ajout_distribution::get_string()
{
QString* buf = new QString();
if(comboBox_var->currentItem()<m->get_var_nb()) *buf = "<distribution var=";
else *buf = "<distribution par=";
*buf += comboBox_var->currentText();
*buf += ">\n<famille>";
*buf += comboBox_famille->currentText();
*buf += "</famille>\n";

QString* buf2 = new QString();
*buf2 = "";
for(int i=0;i<table_def->numRows();i++) {
  if(!table_def->text(i,0).isEmpty()) {
    if(i>0) *buf2 += " , ";
    *buf2 += table_def->text(i,0);    
    }
  }
if(*buf2 != "") {
  if(radioButton_def_moment->isChecked()) *buf += "<moment>" + *buf2 + "</moment>\n";
  else *buf += "<parametre>" + *buf2 + "</parametre>\n";
  }

*buf += "</distribution>\n";

delete buf2;
return(buf);
}

void ajout_distribution::ok()
{accept();}

void ajout_distribution::annuler()
{reject();}

//#include "ajout_distribution.moc"
