/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ajout_equilibre.h"
#include "form_ajout_equilibre.h"

#include <qpushbutton.h>
#include <qtable.h>

ajout_equilibre::ajout_equilibre(qmodele* xm) : Form_ajout_equilibre()
{
QObject::connect(pushButton_ok,SIGNAL(clicked()),this,SLOT(ok()));
QObject::connect(pushButton_annuler,SIGNAL(clicked()),this,SLOT(annuler()));

m =xm;
table_eq->setNumRows(m->get_var_nb());
table_eq->setColumnStretchable (0,TRUE);
for(int i=0;i<m->get_var_nb();i++) {
	table_eq->verticalHeader()->setLabel(i,m->get_var_nom(i));
	table_eq->setText(i,0,"0");
	}
}

QString* ajout_equilibre::get_string()
{
QString* buf = new QString("<eq>");

for(int i=0;i<m->get_var_nb();i++) {
	if(i>0) *buf += " , ";
	*buf += table_eq->text(i,0);
	}
*buf += "</eq>\n";
return(buf);
}


void ajout_equilibre::ok()
{
accept();
}

void ajout_equilibre::annuler()
{
reject();
}

//#include "ajout_equilibre.moc"

