/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ajout_isocline.h"
#include "form_ajout_isocline.h"

#include <qcombobox.h>
#include <qpushbutton.h>
#include <qtable.h>

ajout_isocline::ajout_isocline(qmodele* xm) : Form_ajout_isocline()
{
m = xm;

QObject::connect(pushButton_ok,SIGNAL(clicked()),this,SLOT(ok()));
QObject::connect(pushButton_annuler,SIGNAL(clicked()),this,SLOT(annuler()));
QObject::connect(pushButton_plus,SIGNAL(clicked()),this,SLOT(plus()));
QObject::connect(pushButton_moins,SIGNAL(clicked()),this,SLOT(moins()));

QStringList var_list;
for(int i=0;i<m->get_var_nb();i++) var_list << m->get_var_nom(i);
comboBox_var->insertStringList(var_list);

table_isocline->setNumRows(0);   
table_isocline->setColumnStretchable (1,TRUE);
table_isocline->setSelectionMode(QTable::NoSelection);

plus();
}

void ajout_isocline::plus() {
int nb = table_isocline->numRows();
table_isocline->setNumRows(nb+1);
QStringList var_list;
for(int i=0;i<m->get_var_nb();i++) var_list << m->get_var_nom(i);
QComboTableItem* liste = new QComboTableItem(table_isocline,var_list);
liste->setCurrentItem(0);
liste->setEditable(FALSE);
table_isocline->setItem(nb,0,liste);

table_isocline->setText(nb,1,"0");
}

void ajout_isocline::moins() {
int nb = table_isocline->numRows();

table_isocline->removeRow(nb-1);
}

QString* ajout_isocline::get_string()
{
QString* buf = new QString("<isocline var=");

*buf += comboBox_var->currentText() +">\n";

table_isocline->setReadOnly(TRUE); //force la validation de la table ?
int nb = table_isocline->numRows();
for(int i=0;i<nb;i++) {
	*buf += table_isocline->item(i,0)->text() +" = ";
	*buf += table_isocline->text(i,1) + "\n";
	}

*buf  += "</isocline>";
return(buf);
};

ajout_isocline::~ajout_isocline()
{
}

void ajout_isocline::ok() {
accept();
}

void ajout_isocline::annuler() {
reject();
}

//#include "ajout_isocline.moc"
