/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ajout_jacobienne.h"
#include "form_ajout_jacobienne.h"

#include "qmodel.h"
#include <qpushbutton.h>
#include <qtable.h>

ajout_jacobienne::ajout_jacobienne (qmodele* xm) : Form_ajout_jacobienne ()
{
QObject::connect(pushButton_ok,SIGNAL(clicked()),this,SLOT(ok()));
QObject::connect(pushButton_annuler,SIGNAL(clicked()),this,SLOT(annuler()));

m = xm;
table_jacobienne->setNumRows(m->get_var_nb());
table_jacobienne->setNumCols(m->get_var_nb());

for(int i=0;i<m->get_var_nb();i++) {
	table_jacobienne->setColumnStretchable(i,TRUE);
	table_jacobienne->verticalHeader()->setLabel(i,m->get_var_nom(i));
	table_jacobienne->horizontalHeader()->setLabel(i,m->get_var_nom(i));
	for(int j=0;j<m->get_var_nb();j++) {
		table_jacobienne->setText(i,j,"0");
		}
	}
}

QString* ajout_jacobienne::get_string()
{
QString* buf = new QString("<jacobienne>\n");

for(int i=0;i<m->get_var_nb();i++) {
	for(int j=0;j<m->get_var_nb();j++) {
		if(j>0) *buf += " , ";
		*buf += table_jacobienne->text(i,j);
		}
	*buf +="\n";
	}
*buf +="</jacobienne>\n";
return(buf);
}

void ajout_jacobienne::ok()
{accept();}

void ajout_jacobienne::annuler()
{reject();}

