/***************************************************************************
 *   Copyright (C) 2005 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "chaine.h"

extern FILE* FICHIER_SORTIE;

//on construit la chaone a partir d'une chaine de caractres et d'une liste d'indices
int chaine::construire_chaine_op() {
  if(s==NULL || strlen(s)<=0) return(-1);
  
  int i,j;
  int pos = 0;
   while(pos<nb_c) {
     char* buf = (char*) malloc((nb_c-pos+1)*sizeof(char));
     i = 0;
     if(s[pos]!='&') {
      int nb_g = 0; //nombre de guillemets ouverts
      //si un symbole & est trouv entre deux " il est ignor
      while(pos<nb_c && (s[pos]!='&'||nb_g==1)) { //chaine de caractre
        buf[i]=s[pos];
        pos++;
        i++;
	if(s[pos]=='\"') {if(nb_g==0) nb_g=1; else nb_g=0;}
        }
      buf[i]='\0';
      objet* tmp_o = new objet('s',buf);
      
      if(nb_o==0) chaine_op = (operationSimple**) malloc(sizeof(operationSimple*));
      else        chaine_op = (operationSimple**) realloc(chaine_op,(nb_o+1)*sizeof(operationSimple*));
      
      chaine_op[nb_o] = new operationSimple(&(tmp_o),1,nb_i,index,val,0,NULL,NULL);
      if(chaine_op[nb_o]->valide()==-1) {
         fprintf(FICHIER_SORTIE,"ERREUR chaine::construire_chaine_op - operation non valide pendant la construction de la chaine.\n");
	 return(-1);
	 }
      nb_o++;
      }
     else {       
       pos++;       
       int nbp = 0; //nombre de parenthses ouvertes
       i = pos;
       //on avance jusqu'au prochain caractre non alphanumrique ou tant que toutes les parenthses ne sont pas fermes
       //la routine type_caractere ne distingue pas les '[' et '"'
       if(s[i]=='(') nbp++;
       while(i<nb_c && (nbp!=0 || (type_caractere(s[i])==0 && s[i]!='[' && s[i]!=']' && s[i]!='\"' && s[i]!='\"'))) {
         i++;
	 if(s[i]=='(') nbp++;
	 if(s[i]==')') nbp--;	 
         }            
       if(s[i]!=')') i--;
       for(j=pos;j<=i;j++) buf[j-pos]=s[j];
       buf[j-pos]='\0';
       pos=i+1;
       
       objet** chaine_objet_tmp = NULL;              
       j = lire_chaine_objet(buf,&chaine_objet_tmp,nb_i,index,val,0,0,NULL);
       if(j<=0) {
         fprintf(FICHIER_SORTIE,"ERREUR chaine::construire_chaine_op - problme  la lecture de la chaine d'objets.\n");
	 return(-1);
	 }
       
       if(nb_o==0) chaine_op = (operationSimple**) malloc(sizeof(operationSimple*));
       else        chaine_op = (operationSimple**) realloc(chaine_op,(nb_o+1)*sizeof(operationSimple*));
      
       chaine_op[nb_o] = new operationSimple(chaine_objet_tmp,j,nb_i,index,val,0,NULL,NULL); 
       if(chaine_op[nb_o]->valide()==-1) {
         fprintf(FICHIER_SORTIE,"ERREUR chaine::construire_chaine_op - operation non valide pendant la construction de la chaine.\n");
	 return(-1);
	 }
       nb_o++;           
       }
     free(buf);       
     }
   return(1);
  }
  
chaine::chaine(char* str,int nb_index,char** ind) {
   
   s = NULL; nb_c=0; 
   chaine_op = NULL; nb_o=0;
   index = NULL; nb_i = 0; val = NULL;
         
   if(str==NULL || strlen(str)<=0) return;         
   
   //si la chaine commence par des guillements on les enlve
   if(str[0]=='\"') {
     if(str[strlen(str)-1]!='\"') {
       fprintf(FICHIER_SORTIE,"ERREUR chaine::chaine - \" manquant dans %s\n",str);
       return;
       }
     nb_c = strlen(str)-2;
     s = (char*) malloc((nb_c+1)*sizeof(char));
     int i = 1; int j=0;
     while(i<nb_c && (str[i]=='\"'||str[i]==' '||str[i]=='\t'||str[i]=='\n'||str[i]=='\0')) i++;
     for(;j<nb_c;j++) s[j] = str[i+j];    //on copie tout sauf les " "
     s[j]='\0';
     }
   else {
   //sinon on copie tout
     nb_c = strlen(str);
     s = (char*) malloc((nb_c+1)*sizeof(char));
     int i=0; int j=0;
     while(i<nb_c && (str[i]==' '||str[i]=='\t'||str[i]=='\n'||str[i]=='\0')) i++;
     for(;j<nb_c;j++) s[j] = str[i+j];    //on copie tout
     s[j]='\0';
     }
   
   if(ind==NULL || nb_index == 0) {
     fprintf(FICHIER_SORTIE,"ERREUR chaine::chaine - erreur pendant la construction de la chaine.\n");
     return;   
     }
   for(int i=0;i<nb_i;i++) if(ind[i]==NULL || strlen(ind[i])<=0) {
     fprintf(FICHIER_SORTIE,"ERREUR chaine::chaine - erreur pendant la construction de la chaine.\n");
     return;
     }
   
   index = ind; nb_i = nb_index;
   val = (double*) malloc(nb_i*sizeof(double));   
   for(int i=0;i<nb_i;i++) val[i]=0.0;
   
   //construction de la chaine
   if(construire_chaine_op()==-1) {
    fprintf(FICHIER_SORTIE,"ERREUR chaine::chaine - erreur pendant la construction de la chaine.\n");
    nb_o = 0;
    chaine_op = NULL;
    }
   }

chaine::~ chaine() {
 if(s!=NULL) free(s); s = NULL; nb_c=0; 
 if(chaine_op!=NULL) free(chaine_op); chaine_op = NULL; nb_o=0;
 //les free suivants posent problme si les indices sont partags par plusieurs chaines
 //if(index!=NULL) free(index); 
 //if(val!=NULL) free(val); 
 index = NULL; nb_i = 0; 
 val = NULL;
 }
   
char* chaine::tostring() {
    char* buf = (char*) malloc((nb_c+1)*sizeof(char));
    strcpy(buf,s);
    return(buf);
    }
    
char* chaine::tostring(int* v) {
    char* buf = NULL;
    for(int i=0;i<nb_i;i++) val[i]=v[i];
    for(int i=0;i<nb_o;i++) {      
      operationSimple* o = chaine_op[i];
      if(o!= NULL && o->valide()==1) {      
        if(o->get_ob(0)!=NULL && o->get_ob(0)->get_t()=='s')
          buf = o->get_ob(0)->concatene(&buf);
        else buf = concatene(&buf,o->eval());
	}
      else {
        fprintf(FICHIER_SORTIE,"ERREUR chaine::tostring - opration vide rencontre.\n");
	return(buf);
        }
      }
    return(buf);
    } 
    
//
