/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <iostream.h>
#include <stdlib.h>

#include "math.h"
#include "coordonnees.h"

coordonnees::coordonnees(QPixmap* pict)
{
automatique_x=1;
automatique_y=1;

xmin=0.0;
xmax=1.0;
ymin=0.0;
ymax=1.0;
dx=1.0;
dy=1.0;
xstep=5;
ystep=5;

w=pict->width();
h=pict->height();
marge_g_x= (int)(0.15*w);
marge_d_x= (int)(0.05*w);
marge_g_y= (int)(0.15*h);
marge_d_y= (int)(0.05*h);
lx=w-marge_g_x-marge_d_x;
ly=h-marge_g_y-marge_d_y;
}

coordonnees::~coordonnees()
{
automatique_x=1;
automatique_y=1;

xmin=0.0;
xmax=1.0;
ymin=0.0;
ymax=1.0;
dx=1.0;
dy=1.0;
xstep=5;
ystep=5;

w=0;
h=0;
marge_g_x= 0;
marge_d_x= 0;
marge_g_y= 0;
marge_d_y= 0;
lx=0;
ly=0;
}

void   coordonnees::calcul_tmax_xymax(modele* m) //syst�e de coordonn�s standard
{
if(automatique_x==0 && automatique_y==0) return;
xmin=0.0; xmax = 0.0;
if(automatique_x==1 && automatique_y==0) {
	double x;
	for(int i=0;i<m->get_tr_nb();i++) {
    		x=m->get_trajectoire(i)->get_tmax(); if(x>xmax) xmax=x;   
    		}
}

if(automatique_x==0 && automatique_y==1) {
	double y;

	ymax = 0.0; 
	for(int i=0;i<m->get_tr_nb();i++) {
    		y=m->get_trajectoire(i)->get_xmax(); if(y>ymax) ymax=y;
    		if(i==0) ymin = ymax;
    		y=m->get_trajectoire(i)->get_xmin(); if(y<ymin) ymin=y;            
    		}	
	if(ymax==ymin)  {
		ymin = 0.0;
		ymax = 1.0;
		}
	else {
		double marge;
		marge = (ymax-ymin)*0.025;
  		ymax += marge;
  		if(ymin>marge) 	ymin -= marge;
		}
	}
if(automatique_x==1 && automatique_y==1) {
	double x,y;
	xmin=0.0; xmax = 0.0;  
	ymin=0.0; ymax = 0.0; 
	for(int i=0;i<m->get_tr_nb();i++) {
    		x=m->get_trajectoire(i)->get_tmax(); if(x>xmax) xmax=x;
    		y=m->get_trajectoire(i)->get_xmax(); if(y>ymax) ymax=y;

    		if(i==0) ymin = ymax;

    		y=m->get_trajectoire(i)->get_xmin(); if(y<ymin) ymin=y;            
    	}
	if(xmax==xmin)  {
		xmin=0.0;
		xmax = 1.0;
		}
		
	if(ymax==ymin)  {
		ymin = 0.0;
		ymax = 1.0;
		}
	else {
		double marge;
		marge = (ymax-ymin)*0.025;
  		ymax += marge;
  		if(ymin>marge) 	ymin -= marge;
		}
	}  
}

void   coordonnees::calcul_xymax(modele* m) //syst�e de coordonn�s pour le plan de phase
{

if(automatique_x==0 && automatique_y==0) return;
 
if(automatique_x==1 && automatique_y==0) {
	double x,y;
	for(int i=0;i<m->get_tr_nb();i++) {
    		x=m->get_trajectoire(i)->get_xmax(0); if(x>xmax) xmax=x;   
    		if(i==0) xmin = xmax;		
    		x=m->get_trajectoire(i)->get_xmin(0); if(x<xmin) xmin=x;        
    		}
	double* xx = (double*) malloc(2*sizeof(double));
	for(int i=0;i<m->get_eq_nb();i++) {
		if(m->get_eq(i)->eval(xx)==1) {
			x = xx[0];
			y = xx[1];
			if(x>=0 && y>=0) {
				if(x>xmax) xmax=x;
				if(x<xmin) xmin=x;
				}
			}
    		}
	free(xx);
	
	if(xmax==xmin)  {
		xmin = 0.0;
		xmax = 1.0;
		}
	else {
		double marge;
		marge = (xmax-xmin)*0.025;
  		xmax += marge;
  		if(xmin>marge) xmin -= marge;
		}
}

if(automatique_x==0 && automatique_y==1) {
	double x,y;

	ymin = 0.0; ymax = 0.0; 
	for(int i=0;i<m->get_tr_nb();i++) {
    		y=m->get_trajectoire(i)->get_xmax(1); if(y>ymax) ymax=y;
    		if(i==0) ymin = ymax;
    		y=m->get_trajectoire(i)->get_xmin(1); if(y<ymin) ymin=y;            
    		}
	double* xx = (double*) malloc(2*sizeof(double));
	for(int i=0;i<m->get_eq_nb();i++) {
		if(m->get_eq(i)->eval(xx)==1) {
			x = xx[0];
			y = xx[1];
			if(x>=0 && y>=0) {
				if(x>xmax) xmax=x;
				if(x<xmin) xmin=x;
				}
			}
    		}
	free(xx);
	
	if(ymax==ymin)  {
		ymin = 0.0;
		ymax = 1.0;
		}
	else {
		double marge;
		marge = (ymax-ymin)*0.025;
  		ymax += marge;
  		if(ymin>marge) ymin -= marge;
		}
	}
if(automatique_x==1 && automatique_y==1) {
	double x,y;
	xmin = 0.0; xmax = 0.0;  
	ymin = 0.0; ymax = 0.0; 

	for(int i=0;i<m->get_tr_nb();i++) {
    		x=m->get_trajectoire(i)->get_xmax(0); 
    		y=m->get_trajectoire(i)->get_xmax(1); 

		if(x>xmax) xmax=x;
		if(y>ymax) ymax=y;
		if(i==0) {
			xmin=xmax;
			ymin=ymax;
			}
    		x=m->get_trajectoire(i)->get_xmin(0); if(x<xmin) xmin=x;
    		y=m->get_trajectoire(i)->get_xmin(1); if(y<ymin) ymin=y;   
		         
    		}
	double* xx = (double*) malloc(2*sizeof(double));
	for(int i=0;i<m->get_eq_nb();i++) {
		if(m->get_eq(i)->eval(xx)==1) {
			x = xx[0];
			y = xx[1];
			if(x>=0 && y>=0) {
				if(x>xmax) xmax=x;
				if(x<xmin) xmin=x;
    				if(y>ymax) ymax=y;
				if(y<ymin) ymin=y;
				}
			}
    		}

	double marge;
	if(xmax==xmin)  {
		xmin=0.0;
		xmax = 1.0;
		}
	else {
		marge = (xmax-xmin)*0.025;
  		xmax += marge;
  		if(xmin>marge) 	xmin -= marge;
		}
	if(ymax==ymin)  {
		ymin = 0.0;
		ymax = 1.0;
		}
	else {
		marge = (ymax-ymin)*0.025;
  		ymax += marge;
  		if(ymin>marge) 	ymin -= marge;
		}	

	//d�alage pour �iter d'avoir un point d'�uilibre ou une fin de trajectoire sous la l�ende	
	double dec_g = (55+5)/(double)lx;
	double dec_h = (6+12*m->get_var_nb()+5)/(double)ly;
        
	for(int i=0;i<m->get_eq_nb();i++) {
		if(m->get_eq(i)->eval(xx)==1) {
			x = xx[0];
			y = xx[1];
			if(xmax-x<dec_g*xmax && ymax-y<dec_h*ymax) {
			xmax = xmax*(1.0 + dec_g);
			ymax = ymax*(1.0 + dec_h);
			}
			}
    		}
	free(xx);
	}
}

void   coordonnees::calcul_xmax(modele* m)
{
if(automatique_x==0) return;

if(m->get_tr_nb()==0) {
	xmin = 0.0;
	ymin = 0.0;
	xmax = 1.0;
	ymax = 1.0;	
	}
else {   
	double x;
	xmax = 0.0;  
	for(int i=0;i<m->get_tr_nb();i++) {
    		x=m->get_trajectoire(i)->get_xmax(0); if(x>xmax) xmax=x;
		if(i==0) xmin = xmax;
		x=m->get_trajectoire(i)->get_xmin(0); if(x<xmin) xmin=x;
		}
	if(xmax==xmin)  {
		xmin = 0.0;
		xmax = 1.0;
		}
	else {
		double marge = (xmax-xmin)*0.025;
  		xmax += marge;
  		if(xmin>marge) 	xmin -= marge;
		}
	ymin = xmin;
	ymax = xmax;
	}
}

void coordonnees::calcul_echelle(QPixmap* pict)
  {
w=pict->width();
h=pict->height();
marge_g_x= (int)(0.1*w);
marge_d_x= (int)(0.05*w);
marge_g_y= (int)(0.1*h);
marge_d_y= (int)(0.05*h);
lx=w-marge_g_x-marge_d_x;
ly=h-marge_g_y-marge_d_y;
  
dx 		= xmax-xmin;
dy 		= ymax-ymin;
scale_x 	= lx/dx;
scale_y 	= ly/dy;    
}

void coordonnees::calcul_echelle()
  {  
dx 		= xmax-xmin;
dy 		= ymax-ymin;
scale_x 	= lx/dx;
scale_y 	= ly/dy;    
}

void   coordonnees::set_marge(double g_x,double d_x,double g_y,double d_y) 
{
marge_g_x = (int) (g_x * w);
marge_d_x = (int) (d_x * w);
marge_g_y = (int) (g_y * h);
marge_d_y = (int) (d_y * h);

lx = w - marge_g_x - marge_d_x;
ly = h - marge_g_y - marge_d_y;

calcul_echelle();
}

double coordonnees::get_xmin() {return(xmin);}      
double coordonnees::get_xmax() {return(xmax);}
int    coordonnees::get_xstep() {return(xstep);}
double coordonnees::get_ymin() {return(ymin);}
double coordonnees::get_ymax() {return(ymax);}
int    coordonnees::get_ystep() {return(ystep);}
int    coordonnees::get_automatique_x() {return(automatique_x);}
int    coordonnees::get_automatique_y() {return(automatique_y);}
void   coordonnees::set_xmin(double x) {xmin=x;};
void   coordonnees::set_xmax(double x) {xmax=x;};
void   coordonnees::set_xstep(int i) {if(i>0) xstep = i; else xstep=5;}
void   coordonnees::set_ymin(double y) {ymin=y;};
void   coordonnees::set_ymax(double y) {ymax=y;};
void   coordonnees::set_ystep(int i) {if(i>0) ystep = i; else ystep=5;}
void   coordonnees::set_automatique_x(int i) {if(i==0) automatique_x=0; else automatique_x=1;};
void   coordonnees::set_automatique_y(int i) {if(i==0) automatique_y=0; else automatique_y=1;};

int coordonnees::sc_x(double x)
{
int z = (int) (marge_g_x + scale_x*(x-xmin));
return(z);
};

int coordonnees::sc_y(double y)
{
int z = (int) (h - marge_g_y - scale_y*(y-ymin));
return(z);
};

double coordonnees::usc_x(int x)
{
double z = xmin + (x-marge_g_x)/scale_x;
return(z);
};

double coordonnees::usc_y(int y)
{
double z = ymin + (h - marge_g_y - y)/scale_y;
return(z);
};

int coordonnees::sc_x(double x,double y,double z)
{        
double s = x+y+z;
double xx = (z+y/2.0)/s;    
int    zz = (int) (marge_g_x + scale_x*(xx-xmin));
return(zz);
};

int coordonnees::sc_y(double x,double y,double z)
{
double s = x+y+z;
double yy = y/s;
int zz = (int) (h - marge_g_y - scale_y*(yy-ymin));
return(zz);
};

double coordonnees::usc_x(int x,int y)
{
double xx = xmin + (x-marge_g_x)/scale_x;
double yy = ymin + (h-marge_g_y-y)/scale_y;
double zz = 1.0 - (xx - yy/2.0) - yy;
return(zz);
};

double coordonnees::usc_y(int x,int y)
{
double yy = ymin + (h-marge_g_y-y)/scale_y;
return(yy);
};

double coordonnees::usc_z(int x,int y)
{
double xx = xmin + (x-marge_g_x)/scale_x;
double yy = ymin + (h-marge_g_y-y)/scale_y;
double zz = xx - yy/2.0;  
return(zz);
};

int  coordonnees::point_valide(double x,double y) {
if(x>=xmin && x<=xmax && y>=ymin && y<=ymax) return(1);
else return(0);
}

void coordonnees::troncation_xy(double* x1,double* y1,double* x2,double* y2) {
	while(point_valide(*x1,*y1)==0 || point_valide(*x2,*y2)==0) {
	
		if(*x1!=*x2 && *y1!=*y2) {
			double r = (*y2-*y1)/(*x2-*x1);
			int test = 0;
			if(test==0 && *x1<xmin) {
				*y1 += (xmin-*x1)*r;
				*x1 = xmin;
				test=1;
				}
			if(test==0 && *x1>xmax) {
				*y1 += (xmax-*x1)*r;
				*x1 = xmax;
				test=1;
				}
			if(test==0 && *y1<ymin) {
				*x1 += (ymin-*y1)/r;
				*y1 = ymin;
				test=1;
				}
			if(test==0 && *y1>ymax) {
				*x1 += (ymax-*y1)/r;
				*y1 = ymax;
				test=1;
				}
			
			if(test==0 && *x2<xmin) {
				*y2 = *y1 + (xmin-*x1)*r;
				*x2 = xmin;
				test=1;
				}
			if(test==0 && *x2>xmax) {
				*y2 = *y1 + (xmax-*x1)*r;
				*x2 = xmax;
				test=1;
				}
			if(test==0 && *y2<ymin) {
				*x2 = *x1 + (ymin-*y1)/r;
				*y2 = ymin;
				test=1;
				}
			if(test==0 && *y2>ymax) {
				*x2 = *x1 + (ymax-*y1)/r;
				*y2 = ymax;
				test=1;
				}
			}
		else {
			if(*x1<xmin) *x1=xmin;
			if(*x1>xmax) *x1=xmax;
			if(*x2<xmin) *x2=xmin;
			if(*x2>xmax) *x2=xmax;
			if(*y1<ymin) *y1=ymin;
			if(*y1>ymax) *y1=ymax;
			if(*y2<ymin) *y2=ymin;
			if(*y2>ymax) *y2=ymax;
			}
	}
}

void couleur(QPainter *p,int sp,int sp_nb) {
	QColor c;
	c.setHsv(sp*360/sp_nb, 125, 200);
	p->setPen(c);
}

void couleur(QPainter *p,int sp,int sp_nb,int style) {
	QColor c;
	c.setHsv(sp*360/sp_nb, 125, 200);
	QPen* lpen = new QPen();
	lpen->setColor(c);
	lpen->setWidth(style);
	p->setPen(*lpen);
	delete(lpen);
}

void coordonnees::trace_ligne(QPainter* p,double x1,double y1,double x2,double y2)
{
if(point_valide(x1,y1)==1 || point_valide(x2,y2)==1) {
		double xx1 = x1;
		double yy1 = y1;
		double xx2 = x2;
		double yy2 = y2;
		troncation_xy(&xx1,&yy1,&xx2,&yy2);
		p->drawLine(sc_x(xx1),sc_y(yy1),sc_x(xx2),sc_y(yy2));
		}
}

void coordonnees::trace_ligne(QPainter* p,double* pt1,double* pt2)
{
if(point_valide(pt1[0],pt1[1])==1 || point_valide(pt2[0],pt2[1])==1) {
		double xx1 = pt1[0];
		double yy1 = pt1[1];
		double xx2 = pt2[0];
		double yy2 = pt2[1];
		troncation_xy(&xx1,&yy1,&xx2,&yy2);
		p->drawLine(sc_x(xx1),sc_y(yy1),sc_x(xx2),sc_y(yy2));
		}
}

void coordonnees::trace_courbe(QPainter* p,int x,int y,int nb_pt,double** v) {
	for(int i=1;i<nb_pt;i++) trace_ligne(p,v[i-1][x],v[i-1][y],v[i][x],v[i][y]);
}

void coordonnees::trace_courbe(QPainter* p,int nb_var,int nb_pt,double** v) {
	for(int i=0;i<nb_var;i++) {
		couleur(p,i,nb_var);
		trace_courbe(p,0,i+1,nb_pt,v);
		}
}

void coordonnees::trace_courbe(QPainter* p,int nb_var,int nb_pt,double** v,int style) {
	for(int i=0;i<nb_var;i++) {
		couleur(p,i,nb_var,style);
		trace_courbe(p,0,i+1,nb_pt,v);
		}
}

void coordonnees::trace_fleche(QPainter* p,double x1,double y1,double x2,double y2) {
if(point_valide(x1,y1)!=1 || point_valide(x2,y2)!=1) return;

QPointArray pts;
int i=5;
int j=10;
pts.putPoints(0,4,-j,-i,0,0,-j,i,-j,-i);
	
QColor c;
c.setRgb(50,50,50); p->setBrush(c);

p->save();
if(x1!=x2 && y1!=y2){
	double r = atan((y1-y2)/(x2-x1))*360.0/(2.0*3.141592654);	
	if(x1>x2) r += 180.0;
	p->translate(sc_x(x1),sc_y(y1));
	p->rotate(r);
        p->drawConvexPolygon(pts);
	}
else {
	if(x1==x2) {
		if(y2>y1) p->rotate(90.0);
		else      p->rotate(270.0);
		p->translate(sc_x(x1),sc_y(y1));
        	p->drawConvexPolygon(pts);
		}
	else {
		if(x2>x1) p->rotate(180.0);
		p->translate(sc_x(x1),sc_y(y1));
        	p->drawConvexPolygon(pts);
		}
	}
p->restore();
c.setRgb(255,255,255); p->setBrush(c);
}

void coordonnees::trace_curseur_equilibre(QPainter* p,double* x,int var_nb,int stable) {
QColor c; 
c.setRgb(255,255,255); p->setBrush(c);

QPointArray pts;
pts.putPoints(0,4,2,0,5+2,5,5+2,-5,2,0);

for(int i=0;i<var_nb;i++) {
	if(x[i]>=ymin && x[i]<=ymax) {
		couleur(p,i,var_nb);
		switch(abs(stable)) {
			case 1: {
				c.setRgb(255,255,255);
				p->setBrush(c);
				break;
				}
			case 2: {
				p->setBrush(p->pen().color());
				break;
				}
			case 0: {
				c.setRgb(155,155,155);
				p->setBrush(c);
				break;
				}
			}
		p->save();
		p->translate(sc_x(xmax),sc_y(x[i]));
		p->drawConvexPolygon(pts);
		p->restore();
		}
	}
c.setRgb(255,255,255); p->setBrush(c);
}

void coordonnees::trace_point_equilibre(QPainter* p,double* pt,int nb,int stable)
{
QColor c;  
p->setBrush(c);
switch(abs(stable)) {
			case 1: {
				c.setRgb(255,255,255);
				p->setBrush(c);
				break;
				}
			case 2: {
				c.setRgb(0,0,0);
				p->setBrush(p->pen().color());
				break;
				}
			case 0: {
				c.setRgb(155,155,155);
				p->setBrush(c);
				break;
				}
			}
switch(nb) {
  case 2: {
    if(stable>0) trace_point(p,pt);
    else         trace_dble_point(p,pt);
    break;
    }
  case 3: {
    if(stable>0) trace_point(p,pt[0],pt[1],pt[2]);
    else         trace_dble_point(p,pt[0],pt[1],pt[2]);
    break;
    }
  }
}

void coordonnees::trace_courbe_fleche(QPainter* p,int x,int y,int nb_pt,double** v) {
	trace_fleche(p,v[0][x],v[0][y],v[1][x],v[1][y]);
	trace_courbe(p,x,y,nb_pt,v);
	}

void coordonnees::trace_point(QPainter* p,double x,double y)
{
if(point_valide(x,y)) {
	int wx = (int)(0.025*lx);
	int wy = (int)(0.025*ly);
	p->drawEllipse(sc_x(x)-wx/2,sc_y(y)-wy/2,wx,wy);
	}
}

void coordonnees::trace_point(QPainter* p,double* pt)
{
if(point_valide(pt[0],pt[1])) {
	int wx = (int)(0.025*lx);
	int wy = (int)(0.025*ly);
	p->drawEllipse(sc_x(pt[0])-wx/2,sc_y(pt[1])-wy/2,wx,wy);
	}
}

void coordonnees::trace_point(QPainter* p,double x,double y,double z)
{
if(x>=0 && y>=0 && z >=0 && (x+y+z)>0) {
	int wx = (int)(0.025*lx);
	int wy = (int)(0.025*ly);
	p->drawEllipse(sc_x(x,y,z)-wx/2,sc_y(x,y,z)-wy/2,wx,wy);
	}
}

void coordonnees::trace_dble_point(QPainter* p,double x,double y)
{
if(point_valide(x,y)) {
	int wx = (int)(0.025*lx);
	int wy = (int)(0.025*ly);
	p->drawEllipse(sc_x(x)-wx/2,sc_y(y)-wy/2,wx,wy);
	int d=4; p->setBrush(Qt::white);
	p->drawEllipse(sc_x(x)-(wx-d)/2,sc_y(y)-(wy-d)/2,wx-d,wy-d);
	}
}

void coordonnees::trace_dble_point(QPainter* p,double* pt)
{
if(point_valide(pt[0],pt[1])) {
	int wx = (int)(0.025*lx);
	int wy = (int)(0.025*ly);
	p->drawEllipse(sc_x(pt[0])-wx/2,sc_y(pt[1])-wy/2,wx,wy);
	int d=4; p->setBrush(Qt::white);
	p->drawEllipse(sc_x(pt[0])-(wx-d)/2,sc_y(pt[1])-(wy-d)/2,wx-d,wy-d);
	}
}

void coordonnees::trace_dble_point(QPainter* p,double x,double y,double z)
{
if(x>=0 && y>=0 && z >=0 && (x+y+z)>0) {
	int wx = (int)(0.025*lx);
	int wy = (int)(0.025*ly);
	p->drawEllipse(sc_x(x,y,z)-wx/2,sc_y(x,y,z)-wy/2,wx,wy);
	int d=4; p->setBrush(Qt::white);
	p->drawEllipse(sc_x(x,y,z)-(wx-d)/2,sc_y(y,y,z)-(wy-d)/2,wx-d,wy-d);
	}
}

void coordonnees::trace_ligne(QPainter* p,double x1,double y1,double z1,double x2,double y2,double z2)
{
if(x1>=0 && y1>=0 && z1 >=0 && x2>=0 && y2>=0 && z2 >=0 && (x1+y1+z1>0) && (x2+y2+z2>0))  {
	p->drawLine(sc_x(x1,y1,z1),sc_y(x1,y1,z1),sc_x(x2,y2,z2),sc_y(x2,y2,z2));
	}
}



void coordonnees::dessine_axe(QPainter *p,char* x_nom,char* y_nom)
  {
  QColor c;
  c.setRgb(255,255,255); p->setBrush(c);
  c.setRgb(0,0,0); p->setPen(c);
  QFont font1("Helvetica",14,QFont::Normal,FALSE); 
  QFont font2("Helvetica",10,QFont::Normal,FALSE);    
  QFontMetrics fm1( font1 );
  QFontMetrics fm2( font2 );  
        
  p->drawRect(0,0,w,h);
  p->drawRect(marge_g_x,marge_d_y,lx+1,ly+1);
  if(xmin<0.0 && xmax>0.0) p->drawLine(sc_x(0),sc_y(ymin),sc_x(0),sc_y(ymax));
  if(ymin<0.0 && ymax>0.0) p->drawLine(sc_x(xmin),sc_y(0),sc_x(xmax),sc_y(0));
    
  int x,y;
  QString buf;
  
  //axe des abcisses
  //titre
  p->setFont(font1);
  buf = x_nom; 
  x = marge_g_x + lx/2;  
  int pixelsHigh = fm1.height(); 
  int pixelsWide = fm1.width( buf )+2;
  y = h- marge_g_y + 5 + fm2.height() + 5;   
  p->drawText(QRect::QRect(x-pixelsWide/2,y,pixelsWide,pixelsHigh),Qt::AlignHCenter,buf,-1,0,0);
  //�iquettes
  p->setFont(font2);
  y = h - marge_g_y + 5;
  pixelsHigh = fm2.height();
  for(double z=xmin;dx>0 && z<=xmax+0.5*dx/xstep;z+=dx/xstep) {  
	buf.setNum(z,'g',2);
	pixelsWide = fm2.width( buf ) + 2;        	
	p->drawText(QRect::QRect((int)sc_x(z)-pixelsWide/2.0,(int) y,pixelsWide,pixelsHigh),Qt::AlignHCenter,buf,-1,0,0);  
  	}
	
  //axe des ordon�s
  //titre
  p->setFont(font1);
  buf = y_nom;
  x = marge_g_x - (5 + fm2.height() + 5);
  y = marge_d_y + ly/2;    
  pixelsHigh = fm1.height(); 
  pixelsWide = fm1.width( buf )+2;  
  p->drawText(QRect::QRect(x-pixelsWide,y-pixelsHigh/2.0,pixelsWide,pixelsHigh),Qt::AlignRight,buf,-1,0,0);
  
  //�iquettes
  p->setFont(font2);
  x = marge_g_x-5;
  for(double z=ymin;dy>0 && z<=ymax+0.5*dy/ystep;z+=dy/ystep) {
        buf.setNum(z,'g',2);
	pixelsWide = fm2.width( buf ) + 2;        
	p->drawText(QRect::QRect(x-pixelsWide,sc_y(z)-6,pixelsWide,pixelsHigh),Qt::AlignRight,buf,-1,0,0);
  	}  
  }
  
void coordonnees::dessine_legende(QPainter *p,modele* m) {
QColor c; 
QFont font("Helvetica",10,QFont::Normal,FALSE);
QFontMetrics fm(font);
p->setFont(font);
c.setRgb(0,0,0); 	p->setPen(c);
c.setRgb(255,255,255); 	p->setBrush(c);

QString buf;
  
int x = w - marge_d_x - 5;
int y = marge_d_y + 5;

int l=0; 
int h=0;
int d = 10 + 2;

if(m->get_var_nb()<=10) {
  for(int i=0;i<m->get_var_nb();i++) {
	buf = m->get_var_nom(i);
	if(fm.width(buf)>l) l = fm.width(buf);  //largeur du texte
	}

  l = (int) (l*1.25);	//largeur max du texte
  l += 20;		//longeur de la ligne �tracer
  l += 3+10+3;		//marges et intervalle entre le texte et la ligne
    
  h  = (int) (6 + d*m->get_var_nb());  //hauteur cummul� du texte

  x -= l;
  p->drawRect(x,y,l,h);

  y += 3;     
  for(int i=0;i<m->get_var_nb();i++) {
	couleur(p,i,m->get_var_nb());
	buf = m->get_var_nom(i);
	
	p->drawLine(x+l-3,y+d/2,x+l-3-20,y+d/2);	
	p->drawText(QRect::QRect(x+3,y,l-10-20-3,d),Qt::AlignVCenter,buf,-1,0,0);
	
	y += d;
	}
  }
else {
  
  buf = m->get_var_nom(0);
  l = fm.width(buf);
  buf = m->get_var_nom(m->get_var_nb()-1);
  if(fm.width(buf)>l) l = fm.width(buf);  

  l = (int) (l*1.25);	//largeur max du texte
  l += 20;		//longeur de la ligne �tracer
  l += 3+5+3;		//marges et intervalle entre le texte et la ligne
    
  h = 50;
  
  x -= l;
  p->drawRect(x,y,l,h);
  
  //affichage 1�e et derni�e variables
  buf = m->get_var_nom(0);  
  p->drawText(QRect::QRect(x+3,y+3,l-26,d),Qt::AlignVCenter,buf,-1,0,0);
  buf = m->get_var_nom(m->get_var_nb()-1);  
  p->drawText(QRect::QRect(x+3,y+h-3-d,l-26,d),Qt::AlignVCenter,buf,-1,0,0);
  p->drawText(QRect::QRect(x+3,y+(h-3)/2-d/2,l-26,d),Qt::AlignVCenter,"...",-1,0,0);
  x += l-23;
  y += 3;  
  h -= 6;
  
  for(int i=0;i<h;i++) {
    couleur(p,i,h);    
    p->drawLine(x,y+i,x+20,y+i);
    }
  }
}

void coordonnees::dessine_triangle(QPainter *p,char* x_nom,char* y_nom,char* z_nom) {
  QColor c;
  c.setRgb(255,255,255); p->setBrush(c);
  c.setRgb(0,0,0);       
  QPen* pen_fin   = new QPen (c,0);
  QPen* pen_epais = new QPen (c,2);
    
  QFont font("Helvetica",12,QFont::Normal,1);
  p->setFont(font);  
  p->setPen(*pen_fin);     
  p->drawRect(0,0,w,h);				//trace le carr�et �rit les trois �iquettes
  p->drawText(QRect::QRect(marge_g_x/2,sc_y(1.0,0.0,0.0)+2,lx/2,marge_d_y),Qt::AlignLeft,x_nom,-1,0,0);
  p->drawText(QRect::QRect(sc_x(0.0,1.0,0.0)-lx/2,sc_y(0.0,1.0,0.0)-marge_d_y,lx,marge_d_y-2),Qt::AlignCenter,y_nom,-1,0,0);
  p->drawText(QRect::QRect(w-marge_d_x/2-lx/2,sc_y(0.0,0.0,1.0)+2,lx/2,marge_d_y),Qt::AlignRight,z_nom,-1,0,0);
  
  p->setPen(*pen_epais);  
  trace_ligne(p,1.0,0.0,0.0,0.0,1.0,0.0);	//trace le triangle
  trace_ligne(p,1.0,0.0,0.0,0.0,0.0,1.0);
  trace_ligne(p,0.0,1.0,0.0,0.0,0.0,1.0);  
  p->setPen(*pen_fin); 
  
  delete pen_fin;
  delete pen_epais;   
}
