/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "definir_echelle.h"
#include "form_definir_echelle.h"

#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qtable.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qlineedit.h>

 definir_echelle::definir_echelle() : Form_definir_echelle () {
 
 QObject::connect(checkBox_automatique_x,SIGNAL(stateChanged(int)),this,SLOT(initialise_x()));
 QObject::connect(checkBox_automatique_y,SIGNAL(stateChanged(int)),this,SLOT(initialise_y()));

 QObject::connect(pushButton_ok,SIGNAL(clicked()),this,SLOT(ok()));
 QObject::connect(pushButton_annuler,SIGNAL(clicked()),this,SLOT(annuler()));

 
}

void definir_echelle::set_automatique_x()
{
checkBox_automatique_x->setChecked(TRUE);

lineEdit_x_min->setEnabled(FALSE);
lineEdit_x_max->setEnabled(FALSE);
lineEdit_x_step->setEnabled(FALSE);
textLabel_x_min->setEnabled(FALSE);
textLabel_x_max->setEnabled(FALSE);
textLabel_x_step->setEnabled(FALSE);
};

void definir_echelle::set_automatique_y()
{
checkBox_automatique_y->setChecked(TRUE);

lineEdit_y_min->setEnabled(FALSE);
lineEdit_y_max->setEnabled(FALSE);
lineEdit_y_step->setEnabled(FALSE);
textLabel_y_min->setEnabled(FALSE);
textLabel_y_max->setEnabled(FALSE);
textLabel_y_step->setEnabled(FALSE);
};

void definir_echelle::unset_automatique_x()
{
checkBox_automatique_x->setChecked(FALSE);

lineEdit_x_min->setEnabled(TRUE);
lineEdit_x_max->setEnabled(TRUE);
lineEdit_x_step->setEnabled(TRUE);
textLabel_x_min->setEnabled(TRUE);
textLabel_x_max->setEnabled(TRUE);
textLabel_x_step->setEnabled(TRUE);
};

void definir_echelle::unset_automatique_y()
{
checkBox_automatique_y->setChecked(FALSE);

lineEdit_y_min->setEnabled(TRUE);
lineEdit_y_max->setEnabled(TRUE);
lineEdit_y_step->setEnabled(TRUE);
textLabel_y_min->setEnabled(TRUE);
textLabel_y_max->setEnabled(TRUE);
textLabel_y_step->setEnabled(TRUE);
};

void definir_echelle::initialise_x(bool test) {
if(test) set_automatique_x();
else     unset_automatique_x();
}    

void definir_echelle::initialise_x() {
if(checkBox_automatique_x->isChecked())  set_automatique_x();
else     				 unset_automatique_x();
}  

void definir_echelle::initialise_y(bool test) {
if(test) set_automatique_y();
else     unset_automatique_y();
}    

void definir_echelle::initialise_y() {
if(checkBox_automatique_y->isChecked()) set_automatique_y();
else     				 unset_automatique_y();
} 

void definir_echelle::set_minmax(int type,QString v1,QString v2,coordonnees *coord) {
	textLabel_x->setText(v1);			
	QString buf;
	buf.sprintf("%g",coord->get_xmin()); 
	lineEdit_x_min->setText(buf);
	buf.sprintf("%g",coord->get_xmax()); 
	lineEdit_x_max->setText(buf);
	buf.sprintf("%d",coord->get_xstep()); 
	lineEdit_x_step->setText(buf);
	if(type!=3) {
		checkBox_automatique_y->setEnabled(TRUE);
		textLabel_y->setEnabled(TRUE);
		lineEdit_y_min->setEnabled(TRUE);
		lineEdit_y_max->setEnabled(TRUE);
		lineEdit_y_step->setEnabled(TRUE);
		textLabel_y_min->setEnabled(TRUE);
		textLabel_y_max->setEnabled(TRUE);
		textLabel_y_step->setEnabled(TRUE);
		
		textLabel_y->setText(v2);
		buf.sprintf("%g",coord->get_ymin()); 
		lineEdit_y_min->setText(buf);
		buf.sprintf("%g",coord->get_ymax()); 
		lineEdit_y_max->setText(buf);
		buf.sprintf("%d",coord->get_ystep()); 
		lineEdit_y_step->setText(buf);
		}
	else {
		textLabel_y->setText(v1);
		lineEdit_y_min->setText(lineEdit_x_min->text());
		lineEdit_y_max->setText(lineEdit_x_max->text());
		lineEdit_y_step->setText(lineEdit_x_step->text());
	
		checkBox_automatique_y->setEnabled(FALSE);
		textLabel_y->setEnabled(FALSE);
		lineEdit_y_min->setEnabled(FALSE);
		lineEdit_y_max->setEnabled(FALSE);
		lineEdit_y_step->setEnabled(FALSE);
		}
	}
void definir_echelle::get_minmax(int type,coordonnees *coord) {
	
	coord->set_xmin(lineEdit_x_min->text().toFloat());
	coord->set_xmax(lineEdit_x_max->text().toFloat());
	coord->set_xstep(lineEdit_x_step->text().toInt());
	if(type!=3) {
		coord->set_ymin(lineEdit_y_min->text().toFloat());
		coord->set_ymax(lineEdit_y_max->text().toFloat());
		coord->set_ystep(lineEdit_y_step->text().toInt());
		}
	else {
		coord->set_ymin(coord->get_xmin());
		coord->set_ymax(coord->get_xmax());
		coord->set_ystep(coord->get_xstep());
		}
	}
		
void definir_echelle::ok(){
accept();
}
void definir_echelle::annuler(){
reject();
}

//#include "definir_echelle.moc"
