/***************************************************************************
 *   Copyright (C) 2005 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "fonction.h"
#include "xml.h"

#include "specification_distribution.h"
 
 //classe utilise pour les modles stochastiques    
class distribution { 
 	public :
		distribution();
		distribution(char* cont,int var_nb,char** var_nom,double* var,int par_nb,char** par_nom,double* par);
		distribution(int symb,fonction* f_m,fonction* f_p);
		~distribution();
		
		int    eval(double* x,double* y);   //valuation
		int    eval(double* x);             //valuation
		
		void   ecrire(char* var_nom);	//criture
		int    lire(char* buf,int x_nb,double* x,char** x_nom);
		int    valide();
		
	private :
		int      n;    //nombe de paramtres de la distribution
		int      symb; //la distribution
		int      type; //type de distribution (discrte ou continue)
		
		fonction *f_m;     //moments de la distribution
		fonction *f_p;     //paramtres de la distribution 
		func_pt  f_eval;   //pointeur vers la fonction d'valuation
		func_pt  f_constr; //pointeur vers la fonction calculant les paramtres  partir de f_m
		
		double*  p;        //vecteur des valeurs de paramtres
 };
 
 int    get_type(char* buf);

