/***************************************************************************
                          ksim.h  -  description
                             -------------------
    begin                : lun avr 5 2004
    copyright            : (C) 2004 by Ferdy Jean-Baptiste
    email                : ferdy@univ-montp2.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSIM_H
#define KSIM_H

#include <qwidget.h>
#include <qfiledialog.h>

#include "ksimmain.h"
#include "qmodel.h"

class KSim : public KSimMain  {
   Q_OBJECT
   
public: 
	KSim(QWidget *parent=0, const char *name=0);
	~KSim();

  qmodele* get_m();
  QTable*  get_table_variable();
  QTable*  get_table_parametre();
  void     tabWidget_affichage_selected( const QString & );
  double   get_tmax();  
  void     autorise_affichage();
  void     desactive_affichage(int type);
  void     active_affichage(int type);
  int      type_affichage();
  int      detruit_tout();
  void     calcul(int x_calcul_afficher, int x_calcul_rafraichir);
  void     reinitialise_interface();
  void     rafraichir_interface();
  void     rafraichir_nb_trajectoire();
  void     rafraichir_nb_trajectoire(int i);
  void     legende();
  void     ajout_string(QString texte);
  void     probleme_calcul();
  void     maj_fichier_recent();
  void     maj_fichier_recent(QString nom);
  
public slots:
  void     nouveau();
  void     ouvrir();  
  void     charger();
  void     charger(QString nom);
  void     charger_recent(int i);
  void     recharger();
  void     enregistrer();
  void     enregistrer_sous();
  
  void     raffraichir_xml();
  void     annuler_xml();
  void     refaire_xml();
  void     rafraichir_trajectoire(); 
  void     rafraichir_affichage();
  void     rafraichir_affichage_menu();
  void     rafraichir_affichage_bouton();
  void     raffraichir_log();
  void     purger_log();
  void     lancer();
  void     lancer2();
  void     stop();
  void     supprimer();
  void     supprimer2();
  void     calcul_histograme();
  void     exporter_graphique();  
  void     exporter_trajectoire();
  void     fermer();
  void     quitter();  
  void     a_propos();
  void     menu_aide();
  void     changer_echelle();
  void     activer_echelle_automatique();
  
  void     ajouter_isocline();
  void     ajouter_equilibre();  
  void     ajouter_jacobienne();
  void     ajouter_distribution();
  void     editer_option();
  
private:
  void       lire_settings();  
  void       ecrire_settings();
  
  qmodele    *m;
  QString    fichier_courant;  
  QString    repertoire_courant; 
  
  QFileDialog* dialog_ouvrir_modele;
  QFileDialog* dialog_sauver_modele;
  QFileDialog* dialog_sauver_image;
  QFileDialog* dialog_export_trajectoire;  
};
#endif
