/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "lancer_calcul.h"
#include "form_lancer_2.h"

#include <qpushbutton.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qmessagebox.h>
#include <qfiledialog.h>
#include <qlabel.h>

lancer_calcul::lancer_calcul(qmodele* xm,QString xrepertoire_courant) : Form_lancer_2()
{
QObject::connect(pushButton_ok,SIGNAL(clicked()),this,SLOT(ok()));
QObject::connect(pushButton_annuler,SIGNAL(clicked()),this,SLOT(annuler()));
QObject::connect(comboBox_var_1,SIGNAL(activated(int)),this,SLOT(initialise_var_1()));
QObject::connect(comboBox_var_2,SIGNAL(activated(int)),this,SLOT(initialise_var_2()));

QObject::connect(lineEdit_var_1_min,SIGNAL(textChanged(const QString&)),this,SLOT(affiche_nb_trajectoire()));
QObject::connect(lineEdit_var_1_max,SIGNAL(textChanged(const QString&)),this,SLOT(affiche_nb_trajectoire()));
QObject::connect(lineEdit_var_1_step,SIGNAL(textChanged(const QString&)),this,SLOT(affiche_nb_trajectoire()));
QObject::connect(lineEdit_var_2_min,SIGNAL(textChanged(const QString&)),this,SLOT(affiche_nb_trajectoire()));
QObject::connect(lineEdit_var_2_max,SIGNAL(textChanged(const QString&)),this,SLOT(affiche_nb_trajectoire()));
QObject::connect(lineEdit_var_2_step,SIGNAL(textChanged(const QString&)),this,SLOT(affiche_nb_trajectoire()));
QObject::connect(spinBox_nb_repeat,SIGNAL(valueChanged(int)),this,SLOT(affiche_nb_trajectoire()));

m=xm;
repertoire_courant = xrepertoire_courant;

//construction des combobox
comboBox_var_1->insertItem("Aucune");
for(int i=0;i<m->get_var_nb();i++) comboBox_var_1->insertItem(m->get_var_nom(i));
for(int i=0;i<m->get_par_nb();i++) comboBox_var_1->insertItem(m->get_par_nom(i));

comboBox_var_2->insertItem("Aucune");
for(int i=0;i<m->get_var_nb();i++) comboBox_var_2->insertItem(m->get_var_nom(i));
for(int i=0;i<m->get_par_nb();i++) comboBox_var_2->insertItem(m->get_par_nom(i));
}

void lancer_calcul::ok() {
if(!checkBox_afficher->isChecked() && !checkBox_enregistrer->isChecked()) {
		switch( QMessageBox::warning( this, "KSimPop",
        		"Vous allez effectuer des calculs sans en afficher le rsultat ni l'enregistrer.\n"
        		"Choisissez entre enregistrer ou afficher.\n",
        		"OK",
        		"Annuler", 0, 0, 1 ) ) {
    			case 0: // The user clicked the Retry again button or pressed Enter
			checkBox_afficher->setChecked(TRUE);
			// try again
        		break;
    		case 1: // The user clicked the Quit or pressed Escape
    			reject();
        		break;
    			}
		}
else {
	accept();
 	}
}

void lancer_calcul::annuler() {
reject();
}

void lancer_calcul::affiche_nb_trajectoire() {
int i,j;
i = get_nb_repeat();
if(get_step_1()>0) {
	j = (int)((get_max_1()-get_min_1())/get_step_1());
	if(j>0) i += i*j;
	}
if(get_step_2()>0) {
	j = (int)((get_max_2()-get_min_2())/get_step_2());
	if(j>0) i += i*j;
	}
QString buf;
buf.sprintf("%d trajectoire(s)  calculer.",i);
textLabel_nb_trajectoire->setText(buf);
}

void lancer_calcul::initialise_var_1() {
int nb = comboBox_var_1->currentItem();
switch(nb) {
	case 0 : {
		lineEdit_var_1_min->setText("");
		lineEdit_var_1_max->setText("");
		lineEdit_var_1_step->setText("");
		lineEdit_var_1_min->setEnabled(FALSE);
		lineEdit_var_1_max->setEnabled(FALSE);
		lineEdit_var_1_step->setEnabled(FALSE);
		break;
		}
	default : {
		QString buf;
		buf = comboBox_var_1->currentText();
		int test=1;
		for(nb=0;nb<(m->get_var_nb()+m->get_par_nb()) && test==1;nb++) {
			if(test==1 && nb <  m->get_var_nb() && strcmp(buf.ascii(),m->get_var_nom(nb))==0) test=0;
			if(test==1 && nb >= m->get_var_nb() && strcmp(buf.ascii(),m->get_par_nom(nb-m->get_var_nb()))==0) test=0;
			};
		
		nb--;
		if(nb<m->get_var_nb()) buf.sprintf("%g",m->get_var(nb));
		else 		       buf.sprintf("%g",m->get_par(nb-m->get_var_nb()));
		lineEdit_var_1_min->setText(buf);
		lineEdit_var_1_max->setText(buf);
		lineEdit_var_1_step->setText("1");
		lineEdit_var_1_min->setEnabled(TRUE);
		lineEdit_var_1_max->setEnabled(TRUE);
		lineEdit_var_1_step->setEnabled(TRUE);
		break;
		}
	}
change_var1();
}

void lancer_calcul::initialise_var_2() {
int nb = comboBox_var_2->currentItem();
switch(nb) {
	case 0 : {
		lineEdit_var_2_min->setText("");
		lineEdit_var_2_max->setText("");
		lineEdit_var_2_step->setText("");
		lineEdit_var_2_min->setEnabled(FALSE);
		lineEdit_var_2_max->setEnabled(FALSE);
		lineEdit_var_2_step->setEnabled(FALSE);
		break;
		}
	default : {
		QString buf;
		buf = comboBox_var_2->currentText();
		int test=1;
		for(nb=0;nb<(m->get_var_nb()+m->get_par_nb()) && test==1;nb++) {
			if(test==1 && nb <  m->get_var_nb() && strcmp(buf.ascii(),m->get_var_nom(nb))==0) test=0;
			if(test==1 && nb >= m->get_var_nb() && strcmp(buf.ascii(),m->get_par_nom(nb-m->get_var_nb()))==0) test=0;
			};
		nb--;
		if(nb<m->get_var_nb()) buf.sprintf("%g",m->get_var(nb));
		else 		       buf.sprintf("%g",m->get_par(nb-m->get_var_nb()));
		lineEdit_var_2_min->setText(buf);
		lineEdit_var_2_max->setText(buf);
		lineEdit_var_2_step->setText("1");
		lineEdit_var_2_min->setEnabled(TRUE);
		lineEdit_var_2_max->setEnabled(TRUE);
		lineEdit_var_2_step->setEnabled(TRUE);
		break;
		}
	}
change_var2();
}

void lancer_calcul::change_var1() {
QString txt1 = comboBox_var_1->currentText();
QString txt2 = comboBox_var_2->currentText();

comboBox_var_2->clear();
comboBox_var_2->insertItem("Aucune");
for(int i=0;i<m->get_var_nb();i++) comboBox_var_2->insertItem(m->get_var_nom(i));
for(int i=0;i<m->get_par_nb();i++) comboBox_var_2->insertItem(m->get_par_nom(i));

int i=0;
if(txt1!="Aucune") {
	i++;
	while(comboBox_var_2->text(i)!=txt1) i++;
	comboBox_var_2->removeItem(i);
	}
if(txt1 == txt2 && i>0) comboBox_var_2->setCurrentItem(i+1);
else comboBox_var_2->setCurrentText(txt2);
}

void lancer_calcul::change_var2() {
QString txt1 = comboBox_var_1->currentText();
QString txt2 = comboBox_var_2->currentText();

comboBox_var_1->clear();
comboBox_var_1->insertItem("Aucune");
for(int i=0;i<m->get_var_nb();i++) comboBox_var_1->insertItem(m->get_var_nom(i));
for(int i=0;i<m->get_par_nb();i++) comboBox_var_1->insertItem(m->get_par_nom(i));

int i=0;
if(txt2!="Aucune") {
	i++;
	while(comboBox_var_1->text(i)!=txt2) i++;
	comboBox_var_1->removeItem(i);
	}
if(txt1 == txt2 && i>0) comboBox_var_1->setCurrentItem(i+1);
else comboBox_var_1->setCurrentText(txt1);
}

int lancer_calcul::get_nb_repeat()
{
return(spinBox_nb_repeat->value());
};

void lancer_calcul::set_nb_repeat(int i) {
spinBox_nb_repeat->setValue(i);
};

double lancer_calcul::get_min_1()
{
if(comboBox_var_1->currentItem()==0) return(0);
double x = lineEdit_var_1_min->text().toFloat();
return(x);
};

void lancer_calcul::set_min_1(double x)
{
QString buf; buf.setNum(x);
lineEdit_var_1_min->setText(buf);
};

double lancer_calcul::get_max_1()
{
if(comboBox_var_1->currentItem()==0) return(0);
double x = lineEdit_var_1_max->text().toFloat();
return(x);
};

void lancer_calcul::set_max_1(double x)
{
QString buf; buf.setNum(x);
lineEdit_var_1_max->setText(buf);
};

double lancer_calcul::get_step_1()
{
if(comboBox_var_1->currentItem()==0) return(0);
double x = lineEdit_var_1_step->text().toFloat();
return(x);
};

void lancer_calcul::set_step_1(double x)
{
QString buf; buf.setNum(x);
lineEdit_var_1_step->setText(buf);
};

double lancer_calcul::get_min_2()
{
if(comboBox_var_2->currentItem()==0) return(0);
double x = lineEdit_var_2_min->text().toFloat();
return(x);
};

void lancer_calcul::set_min_2(double x)
{
QString buf; buf.setNum(x);
lineEdit_var_2_min->setText(buf);
};

double lancer_calcul::get_max_2()
{
if(comboBox_var_2->currentItem()==0) return(0);
double x = lineEdit_var_2_max->text().toFloat();
return(x);
};

void lancer_calcul::set_max_2(double x)
{
QString buf; buf.setNum(x);
lineEdit_var_2_max->setText(buf);
};

double lancer_calcul::get_step_2()
{
if(comboBox_var_2->currentItem()==0) return(0);
double x = lineEdit_var_2_step->text().toFloat();
return(x);
};

void lancer_calcul::set_step_2(double x)
{
QString buf; buf.setNum(x);
lineEdit_var_2_step->setText(buf);
};

int lancer_calcul::get_var_1()
{
QString txt = comboBox_var_1->currentText();
int i=0;
while(i<m->get_var_nb() && txt!=m->get_var_nom(i)) i++;

if(i>=m->get_var_nb()) return(-1);
return(i);
}

int lancer_calcul::get_par_1()
{
QString txt = comboBox_var_1->currentText();
int i=0;
while(i<m->get_par_nb() && txt!=m->get_par_nom(i)) i++;

if(i>=m->get_par_nb()) return(-1);
return(i);
}

int lancer_calcul::get_var_2()
{
QString txt = comboBox_var_2->currentText();
int i=0;
while(i<m->get_var_nb() && txt!=m->get_var_nom(i)) i++;

if(i>=m->get_var_nb()) return(-1);
return(i);
}

int lancer_calcul::get_par_2()
{
QString txt = comboBox_var_2->currentText();
int i=0;
while(i<m->get_par_nb() && txt!=m->get_par_nom(i)) i++;

if(i>=m->get_par_nb()) return(-1);
return(i);
}

const char* lancer_calcul::get_nom_1()
{
if(comboBox_var_1->currentItem()==0) return(NULL);
QString txt = comboBox_var_1->currentText();
return(txt.ascii());
}

const char* lancer_calcul::get_nom_2()
{
if(comboBox_var_2->currentItem()==0) return(NULL);
QString txt = comboBox_var_2->currentText();
return(txt.ascii());
}

//#include "lancer_calcul.moc"
