/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LANCER_CALCUL_H
#define LANCER_CALCUL_H

#include "form_lancer_2.h"
#include "qmodel.h"

/**
@author Ferdy Jean-Baptiste
*/
class lancer_calcul : public Form_lancer_2 {
Q_OBJECT

public:
    lancer_calcul(qmodele* m,QString xrepertoire_courant);
    int    get_nb_repeat();
    double get_min_1();
    double get_max_1();
    double get_step_1();
    double get_min_2();
    double get_max_2();
    double get_step_2();
    int    get_var_1();
    int    get_var_2();
    int    get_par_1();
    int    get_par_2();
    
    void   set_nb_repeat(int i);
    void   set_min_1(double x);
    void   set_max_1(double x);
    void   set_step_1(double x);
    void   set_min_2(double x);
    void   set_max_2(double x);
    void   set_step_2(double x);
    void   set_var_1(int i);
    void   get_var_2(int i);
    void   set_par_1(int i);
    void   set_par_2(int i);
    
    const char*  get_nom_1();
    const char*  get_nom_2();
    //QString      nom_fichier();
    
    void   change_var1();
    void   change_var2();
    
    void   progres(int i);    
    
public slots:
	void ok();
	void annuler();
	void initialise_var_1();
	void initialise_var_2();
	//void ouvrir();
	//void deverouille_fichier();
	void affiche_nb_trajectoire();
	
private:
	qmodele* m;
	QString repertoire_courant;
};

#endif
