/***************************************************************************
 *   Copyright (C) 2004 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qdir.h>
#include <qapplication.h>
#include <qsplashscreen.h> 

#include "ksim.h"

int main(int argc, char **argv)
{
    QApplication a( argc, argv );
    
    
    QPixmap* p = new QPixmap("ksimpop.splash.png");
    if(! p->isNull() ) {
     QSplashScreen *splash = new QSplashScreen( *p );
     splash->show();
     }
   
    charge_specification_fonction();        
    charge_specification_distribution();
    //ecrire_index_fonctions("index_fonction.html");
    
    KSim * mw = new KSim();                    
    mw->setCaption( "ksimpop" );
    mw->show();
    a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
    if(argc>1) mw->charger(argv[1]);
                  
    return a.exec();    
}
