/***************************************************************************
 *   Copyright (C) 2005 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 #include "matrice.h"
 extern FILE* FICHIER_SORTIE;
 
 int ecrire_chaine_matrice(int c,int l,int nc,int nl,char* buf,char** s) {
  if(buf==NULL || strlen(buf)<=0) return(-1);  
  int i=0;
  int n=strlen(buf);  
  if((*s)!=NULL) {free(*s); *s = NULL;}

  
  while(i<n) {
    if(buf[i]=='&' && i+1<n) {      
      switch(buf[i+1]) {
        case 'l': {(*s) = concatene(s,l); i+=2; break;}
	case 'c': {(*s) = concatene(s,c); i+=2; break;}
	case 'n': {
	   if(i+2<n) {
	     switch(buf[i+2]) {
	      case 'l': {(*s) = concatene(s,nl); i+=3; break;}
	      case 'c': {(*s) = concatene(s,nc); i+=3; break;}
	      default : {(*s) = concatene(s,nl); i+=2; break;}
	      }
	    }
	   else {
	     (*s) = concatene(s,nl);
	     i+=1;
	     }
	   break;
	   }
	default : {	  
	  (*s) = concatene(s,buf[i]);
          i++;
	  }
	}      
      }
    else {
      (*s) = concatene(s,buf[i]);      
      i++;
      }
    }
  return(0);
  }

int lire_val(char* s,int* x)  {  
  if(s==NULL || strlen(s)<=0) return(-1);
  *x = 0;
  int i = 0;
  int n = strlen(s);
  while(i<n && (s[i]!='-'&& (s[i]<'0' || s[i]>'9'))) i++;      
  if(i>=n) return(-1);
  *x = atoi(&(s[i]));  
  return(1);
}

int lire_val(char* s,int* x,int* nx,char c)  {  
  if(s==NULL || strlen(s)<=0) return(-1);      
  *x=0; *nx=0;
  int n=strlen(s);
  int i=0;      
  while(i<n && s[i]!='-' && (s[i]<'0' || s[i]>'9')) i++;
  if(i>=n) return(-1);
  
  *x = atoi(&(s[i]));
    
  while(i<n && s[i]=='-') i++;
  while(i<n && (s[i]>='0' && s[i]<='9')) i++;      
  while(i<n && (s[i]==' ' || s[i]=='\t')) i++;
  
  //pas de deuxime valeur
  if(i>=n) return(1);
  
  //deuxime valeur mais sparateur entre x et nx incorrect
  if(s[i]!=c) return(-1);
  
  while(i<n && (s[i]<'0' || s[i]>'9') && s[i]!='-') i++;
  if(i>=n) return(-1);
  
  *nx = atoi(&(s[i]));
  
  return(1);
}

//traitement des balises <matrice>
//renvoit  une chane de charactre dcrivant un tableau
char* construit_matrice(char* texte,char* tag,int var_nb)  {  
  int     i,j;
  int     nl,nc; //taille
  chaine* ch_tmp;
    
  char* buf = NULL;
  if(tag!=NULL) {
    buf = lire_valeur_tag(tag,(char*)"taille");
    if(lire_val(buf,&nl)==1) nc=nl;
    else           {
      if(buf!=NULL) free(buf);
            
      buf = lire_valeur_tag(tag,(char*)"nl");
      if(lire_val(buf,&nl)==-1) nl=var_nb;
      if(buf!=NULL) free(buf);
          
      buf = lire_valeur_tag(tag,(char*)"nc");
      if(lire_val(buf,&nc)==-1) nc=var_nb;
      if(buf!=NULL) free(buf);                  
      }
    }
  else {
    nl = var_nb;
    nc = var_nb;
    }
  int nmin = nl<nc ? nl:nc;
  if(nmin<=0) {
    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - matrice %d X %d invalide !\n",nl,nc);
    return(NULL);
    }
        
  //indices utiliss dans les chaines
  int nb_i = 5;
  char** ind = (char**) malloc(nb_i*sizeof(char*));
  ind[0] = (char*) malloc(2*sizeof(char)); strcpy(ind[0],"l");
  ind[1] = (char*) malloc(2*sizeof(char)); strcpy(ind[1],"c");
  ind[2] = (char*) malloc(3*sizeof(char)); strcpy(ind[2],"nl");
  ind[3] = (char*) malloc(3*sizeof(char)); strcpy(ind[3],"nc");
  ind[4] = (char*) malloc(2*sizeof(char)); strcpy(ind[4],"n");
  
  int* v_ind = (int*) malloc(5*sizeof(int));
  v_ind[2] = nl; v_ind[3] = nc; v_ind[4] = nl;
  
  //valeur par dfaut
  buf = lire_valeur_tag(tag,(char*)"defaut");
    
  //constuction du tableau et criture des valeurs par dfaut       
  char*** tab = (char***) malloc(nl*sizeof(char**));
  if(buf!=NULL) {
    chaine* ch_tmp = new chaine(buf,nb_i,ind);
    free(buf); buf=NULL;
    
    if(ch_tmp->valide()==-1) return(NULL);
        
    for(int i=0;i<nl;i++) {
      tab[i] = (char**) malloc(nc*sizeof(char*));
      for(int j=0;j<nc;j++) {
        v_ind[0] = i+1; v_ind[1] = j+1;
        tab[i][j] = (char*) ch_tmp->tostring(v_ind);      
        }
      }
    delete ch_tmp;
  }
  else {
    for(int i=0;i<nl;i++) {
      tab[i] = (char**) malloc(nc*sizeof(char*));
      for(int j=0;j<nc;j++) {        
        tab[i][j] = (char*) malloc(sizeof(char));      
	tab[i][j][0] = '\0';
        }
      }
    }        
  
  int n =strlen(texte);
  
  int pos=0;
  char *xbal  = NULL;
  char *xcont = NULL;
  char *xtag  = NULL;
  
  
  while(pos>-1 && pos<n) {
    if(xbal!=NULL)  {free(xbal);  xbal=NULL;}
    if(xtag!=NULL)  {free(xtag);  xtag=NULL;}
    if(xcont!=NULL) {free(xcont); xcont=NULL;}    
    //recherche la balise suivante    
    i = lire_balise(&(texte[pos]),&xbal,&xtag,&xcont);          
    if(i!=-1 && xbal!=NULL) {
      pos+=i;
//traitement des balises**************
      //diagonale
      if(strcmp(xbal,"diagonale")==0) {
        int x = 0;
        if(xtag!=NULL) {        	
	  buf = lire_valeur_tag(xtag,(char*)"pos");
	  if(lire_val(buf,&x)==1) {x=-x; free(buf); buf=NULL;}
	  else {
	    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - pos manquant dans une balise <diagonale> !\n");
	    pos=-1; break;
	    }	  
	  }
        if(xcont!=NULL) {
	  remplace_char(xcont,'\n',' ');
	  ch_tmp = new chaine(xcont,nb_i,ind);
          for(i=0;i<nc && ch_tmp->valide()==1;i++) {
	    if(i+x>=0 && i+x<nl) {
	      v_ind[0]=i+x+1; //ligne
	      v_ind[1]=i+1;   //colone
	      tab[i+x][i] = ch_tmp->tostring(v_ind);
	      }
	    }
	  if(ch_tmp!=NULL) delete ch_tmp;
	  }
        }
	
      //ligne
      if(strcmp(xbal,"ligne")==0) {
        int x = 1;
	int y = 1; int ny = nc;
        if(xtag!=NULL) {        	
	  buf = lire_valeur_tag(xtag,(char*)"l");
	  if(lire_val(buf,&x)==1) {free(buf); buf=NULL;}
	  else {
	    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - l manquant dans une balise <ligne> !\n");
	    pos=-1; break;
	    }
	  if(x<0) x+=nl+1;  
	  
	  buf = lire_valeur_tag(xtag,(char*)"c");	  
	  lire_val(buf,&y,&ny,':');  
	  free(buf); buf=NULL;
	  if(y<0)  y+=nc+1;
	  if(ny<0) ny+=nc+1;
	  }
        if(xcont!=NULL && x>0 && x<=nl) {
	  remplace_char(xcont,'\n',' ');
          ch_tmp = new chaine(xcont,nb_i,ind);
	  v_ind[0]=x;       //ligne
	  for(i=y-1;i<ny && ch_tmp->valide()==1;i++) {
	    v_ind[1]=i+1;   //colone
	    tab[x-1][i] = ch_tmp->tostring(v_ind);
	    }
	  if(ch_tmp!=NULL) delete ch_tmp;
	  }
	}        
      //colone
      if(strcmp(xbal,"colone")==0) {
        int x = 1;
	int y = 1; int ny = nl;
        if(xtag!=NULL) {        	
	  buf = lire_valeur_tag(xtag,(char*)"c");
	  if(lire_val(buf,&x)==1) {free(buf); buf=NULL;}
	  else {
	    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - c manquant dans une balise <colone> !\n");
	    pos=-1; break;
	    }
	  if(x<0) x+=nc+1;
	  
	  buf = lire_valeur_tag(xtag,(char*)"l");	  
	  lire_val(buf,&y,&ny,':');  
	  free(buf); buf=NULL;
	  if(y<0)  y+=nl+1;
	  if(ny<0) ny+=nl+1;
	  }
	  
        if(xcont!=NULL && x>0 && x<=nc) {
	  remplace_char(xcont,'\n',' ');
	  ch_tmp = new chaine(xcont,nb_i,ind);
	  v_ind[1]=x;       //colone
	  for(i=y-1;i<ny && ch_tmp->valide()==1;i++) {
	    v_ind[0]=i+1;   //ligne
	    tab[i][x-1] = ch_tmp->tostring(v_ind);
	    }
	  if(ch_tmp!=NULL) delete ch_tmp;
          }
	}
      //bloc
      if(strcmp(xbal,"bloc")==0) {
        if(xtag!=NULL) {
	  int x,y,nx,ny;
	  buf = lire_valeur_tag(xtag,(char*)"c");
	  if(lire_val(buf,&x,&nx,':')==-1) {
	    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - c manquant ou invalide dans une balise <bloc> !\n");
	    pos=-1; break;
	    }
	  free(buf); buf=NULL;
	  if(x<0)  x+=nc+1;
	  if(nx!=0) {if(nx<0) nx+=nc+1; nx=nx-x+1;}
	    
	  
	  buf = lire_valeur_tag(xtag,(char*)"l");
	  if(lire_val(buf,&y,&ny,':')==-1) {
	    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - l manquant ou invalide dans une balise <bloc> !\n");
	    pos=-1; break;
	    }
	  free(buf); buf=NULL;  
	  if(y<0) y+=nl+1;
	  if(ny!=0) {if(ny<0) ny+=nl+1; ny=ny-y+1;}
	    
	  buf = lire_valeur_tag(xtag,(char*)"nc");
	  if((nx==0 || abs(nx)>nc) && lire_val(buf,&nx)==-1) nx=nc-x+1;
	  if(buf!=NULL) free(buf);
	  
	  buf = lire_valeur_tag(xtag,(char*)"nl");
	  if((ny==0 || abs(ny)>nl) && lire_val(buf,&ny)==-1) ny=nl-y+1;
	  if(buf!=NULL) free(buf);

          if(xcont!=NULL && x>0 && x<=nc && y>0 && y<=nl && nx!=0 && ny!=0) {
	    remplace_char(xcont,'\n',' ');
            ch_tmp = new chaine(xcont,nb_i,ind);
	    if(ch_tmp->valide()==1) {
	      int dx,dy;
	      if(nx<0) dx=-1; else dx=1;
	      if(ny<0) dy=-1; else dy=1;	  
	      for(i=0;abs(i)<abs(nx) && x-1+i>=0 && x-1+i<nc;i+=dx)  {
	        for(j=0;abs(j)<abs(ny) && y-1+j>=0 && y-1+j<nl;j+=dy) {
	          v_ind[0]=y+j;   //ligne
	          v_ind[1]=x+i;   //colone
	          tab[y-1+j][x-1+i] = ch_tmp->tostring(v_ind);     
	          }
	        }
	      delete ch_tmp;
	      }
	    }
	  }
        }
      //case
      if(strcmp(xbal,"case")==0) {
        int x = 1;
	int y = 1;
        if(xtag!=NULL) {        	
	  buf = (char*) lire_valeur_tag(xtag,(char*)"c");	  
	  if(buf!=NULL) {x = atoi(buf); free(buf); buf=NULL;}
	  else {
	    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - c manquant dans une balise <case> !\n");
	    pos=-1; break;
	    }
	  if(x<0) x+=nc+1;
	  buf = (char*) lire_valeur_tag(xtag,(char*)"l");
	  if(buf!=NULL) {y = atoi(buf); free(buf); buf=NULL;}
	  else {
	    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - l manquant dans une balise <case> !\n");
	    pos=-1; break;
	    }
	  if(y<0) y+=nl+1;
	  //if(buf!=NULL)  {free(buf); buf=NULL;}
	  }
        if(xcont!=NULL && x>0 && x<=nc && y>0 && y<=nl) {
	   remplace_char(xcont,'\n',' ');
	   ch_tmp = new chaine(xcont,nb_i,ind);
	   if(ch_tmp->valide()==1) {
	     v_ind[0]=x;   //ligne
	     v_ind[1]=y;   //colone
	     tab[x-1][y-1] = ch_tmp->tostring(v_ind);
	     delete ch_tmp;
	     }
	   }
        }
	//case
        if(strcmp(xbal,"operation")==0) {
	  if(xtag!=NULL && xcont!=NULL) {
	    buf = (char*) lire_valeur_tag(xtag,(char*)"type");
	    if(buf==NULL) {
	      fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - le type d'opration n'est pas dfini dans une balise <operation> !\n");
	      pos=-1; break;
	      }
	    
	    char t = buf[0];
	    if(t!='+' && t!='-' && t!='*' && t!='/') {
	      fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - l'opration %c n'est pas gre dans les balise <operation> !\n",t);
	      pos=-1; break;
	      }
	    
	    int x,y,nx,ny;
	    
	    buf = lire_valeur_tag(xtag,(char*)"c");
	    if(lire_val(buf,&x,&nx,':')==-1) {
	      fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - c manquant ou invalide dans une balise <opration> !\n");
	      pos=-1; break;
	      }
	    free(buf); buf=NULL;
	    if(x<0)  x+=nc+1;
	    if(nx!=0) {if(nx<0) nx+=nc+1; nx=nx-x+1;}
	    
	  
	    buf = lire_valeur_tag(xtag,(char*)"l");
	    if(lire_val(buf,&y,&ny,':')==-1) {
	      fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - l manquant ou invalide dans une balise <opration> !\n");
	      pos=-1; break;
	      }
	    free(buf); buf=NULL;  
	    if(y<0) y+=nl+1;
	    if(ny!=0) {if(ny<0) ny+=nl+1; ny=ny-y+1;}
	    
	    buf = lire_valeur_tag(xtag,(char*)"nc");
	    if((nx==0 || abs(nx)>nc) && lire_val(buf,&nx)==-1) nx=nc-x+1;
	    if(buf!=NULL) free(buf);
	  
	    buf = lire_valeur_tag(xtag,(char*)"nl");
	    if((ny==0 || abs(ny)>nl) && lire_val(buf,&ny)==-1) ny=nl-y+1;
	    if(buf!=NULL) free(buf);
	    
	    remplace_char(xcont,'\n',' ');
	    ch_tmp = new chaine(xcont,nb_i,ind);
	    if(ch_tmp->valide()==1) {   
	    int dx,dy;
	    if(nx<0) dx=-1; else dx=1;
	    if(ny<0) dy=-1; else dy=1;	  
	    for(i=0;abs(i)<abs(nx) && x-1+i>=0 && x-1+i<nc;i+=dx)  {
	     for(j=0;abs(j)<abs(ny) && y-1+j>=0 && y-1+j<nl;j+=dy) {
	       v_ind[0]=y+j;   //ligne
	       v_ind[1]=x+i;   //colone
	       tab[y-1+j][x-1+i] = ::concatene(&(tab[y-1+j][x-1+i]),t);
	       tab[y-1+j][x-1+i] = ::concatene(&(tab[y-1+j][x-1+i]),ch_tmp->tostring(v_ind));     
	       }
	     }
           delete ch_tmp;
	   }
	}
      }    
    }
    else  pos = n;    
  }
  
  free(v_ind);
  for(int i=0;i<4;i++) free(ind[i]); free(ind);  
  if(xbal!=NULL)  {free(xbal);  xbal=NULL;}
  if(xtag!=NULL)  {free(xtag);  xtag=NULL;}
  if(xcont!=NULL) {free(xcont); xcont=NULL;}
  
  //erreur
  if(pos == -1) {
    for(int i=0;i<nl;i++) {
      for(int j=0;j<nc;j++) {
        if(tab[i][j]!=NULL)free(tab[i][j]);
        }
      free(tab[i]);
      }
    free(tab);
    fprintf(FICHIER_SORTIE,"ERREUR construit_matrice - erreur dans la construction de la matrice !\n");
    return(NULL);
    }
  
  //pas d'erreur  
  buf = (char*) malloc(sizeof(char));
  buf[0]='\0';
  for(int i=0;i<nl;i++) {
    for(int j=0;j<nc;j++) {
      if(tab[i][j]!=NULL) {
        buf = (char*) realloc(buf,(strlen(buf)+1+strlen(tab[i][j])+2)*sizeof(char));      
        sprintf(buf,"%s%s",buf,tab[i][j]);
	}
      else buf = (char*) realloc(buf,(strlen(buf)+1+2)*sizeof(char));
      if(j<nc-1) sprintf(buf,"%s, ",buf);
      else       sprintf(buf,"%s\n",buf);
      free(tab[i][j]);
      }
    free(tab[i]);
    }
  free(tab);
  return(buf);
}

//
