/***************************************************************************
                          model.cpp  -  description
                             -------------------
    begin                : mer fv 25 2004
    copyright            : (C) 2004 by Ferdy Jean-Baptiste
    email                : ferdy@univ-montp2.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "model.h"

 
int    MODELE_ERREUR_LECTURE;   //erreur renvoye  la lecture du modle
extern FILE* FICHIER_SORTIE;    //fichier de sortie

//isocline-------------------------------------------------------
//---------------------------------------------------------------
//constructeur et destructeur------------------------------------
//---------------------------------------------------------------
isocline::isocline(int i,int j,int l_var_nb,int l_par_nb,char** l_var_nom,char** l_par_nom,double* l_var,double* l_par,char* s) {  
  var_const = i; //variable dont le taux de croissance est nul
  var_dep   = j; //variable calcule
  x     = l_var;
  y     = new fonction(1,l_var_nb,l_par_nb,l_var_nom,l_par_nom,l_var,l_par,&s);
  if(y==NULL) {
  	var_const = -1;
	var_dep   = -1;
	x = NULL;
	}  
  }
  
isocline::~isocline() {
	var_const = -1;
	var_dep   = -1;
	x = NULL;      //on ne free pas par ce que c'est juste un pointeur vers le tableau des variables
	delete y;
  }
//routines de base-----------------------------------------------
//---------------------------------------------------------------

int isocline::get_var_const() {
  return(var_const);
  }

int isocline::get_var_dep() {
  return(var_dep);
  }
  
fonction* isocline::get_y() {return(y);}
    
void isocline::ecrire(FILE* fichier,double xmax) {
  double* range = (double*) malloc(3*sizeof(double));
  range[0]=0.0; range[1]=xmax; range[2]=xmax/100.0;
  double** v = y->graphe(0,range);
  free(range);

  int n = (int)((range[1]-range[0])/range[2] +1);
  for(int i=0;i<n;i++) fprintf(fichier,"%g %g\n",v[i][0],v[i][1]);
  }
  
//modele---------------------------------------------------------
//---------------------------------------------------------------

//constructeur et destructeur------------------------------------
//---------------------------------------------------------------
int modele::lire_distribution(char* tag,char* buf,int x_nb,char** x_nom,distribution** x_dist) {
	if(tag==NULL || strlen(tag)<5) return(0);
        int i = recherche_nom(&(tag[4]),x_nb,x_nom);
	if(i==-1) { //variable non trouve
		fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - balise <distribution var=x> fait rfrence ");
		if(strncmp(tag,"var",3)==0) fprintf(FICHIER_SORTIE," une variable %s inconnue\n",&(tag[4]));
		else 			    fprintf(FICHIER_SORTIE," un paramtre %s inconnu\n",&(tag[4]));
		return(-1);
		}
	x_dist[i] = new distribution(buf,var_nb,var_nom,var,par_nb,par_nom,par);

	if(x_dist[i]->valide()==-1) {
	  fprintf(FICHIER_SORTIE,"ERREUR modele::lire_distribution - impossible de lire la distribution de %s\n",&(tag[4]));
	  x_dist[i] = NULL;
	  return(-1);
	  };
	return(i); //renvoit le paramtre ou la variable qui est stochastique
  }

int  modele::set_var_ini(char** s) {
  if(var_ini!=NULL) {     
    sfonction* var_ini_tmp  = new sfonction(var_nb,var_nb,par_nb,var_nom,par_nom,var,par,s);            
    if(var_ini_tmp==NULL || var_ini->get_nb()<=0) {
      if(var_ini!=NULL) delete(var_ini);
      var_ini = NULL;
      fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - impossible de lire les valeur initiales des variables\n");
      return(-1);
      }                
    distribution** var_dist = var_ini->get_var_dist();
    var_ini_tmp->set_var_dist(var_dist);    
    for(int i=0;i<var_nb && var_dist!=NULL;i++) {
      if(var_dist[i]!=NULL && var_ini_tmp->is_var_dep(&(var[i]))==1) {var_ini_tmp->set_var_stochastique(1); break;}
      }
    distribution** par_dist = var_ini->get_par_dist();
    var_ini_tmp->set_par_dist(par_dist);    
    for(int i=0;i<par_nb && par_dist!=NULL;i++) {
      if(par_dist[i]!=NULL && var_ini_tmp->is_var_dep(&(par[i]))==1) {var_ini_tmp->set_par_stochastique(1); break;}
      }
      
    var_ini->set_var_dist(NULL);
    var_ini->set_par_dist(NULL);
    delete(var_ini);  
    
    var_ini = var_ini_tmp;
    }
  else {  
    var_ini  = new sfonction(var_nb,var_nb,par_nb,var_nom,par_nom,var,par,s);
    var_ini->set_var_dist(NULL);
    var_ini->set_par_dist(NULL);
    }
  
  if(var_ini==NULL || var_ini->get_nb()<=0) {
    if(var_ini!=NULL) {delete(var_ini); var_ini = NULL;}
    fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - impossible de lire les valeurs initiales des variables\n");
    return(-1);
    }
  return(1);
  }
  
void  modele::get_var_ini(char*** s) {
  if(var_ini!=NULL) var_ini->fonction::ecrire(s);
  }  
  
//******************************************************************************************************************
//lecture du modle  partir d'une chaine de caractres
int modele::ouvrir_modele(char* s) {
  int    i,n,test,context;
  char   *buf,*tag,*texte;
  char   **bufs1,**bufs2;
  
  context = -1;     //contexte sert  dtecter, en cas d'erreur, l'endroit o l'erreur s'est produite
  		    // chaque nouveau type de balise lu, contexte est chang
            
  //lecture du modle
  buf = lire_balise_obl(s,(char*)"modele");
  if(buf==NULL) {return(context);};
      
  texte=buf;   
  
  //lecture du nom
  //**************
  description = lire_balise(texte,(char*)"nom");
         
  context--;
  //lecture des paramtres
  //*********************  
  buf = lire_balise(texte,(char*)"parametre");		//recherche la balise
  if(buf!=NULL) par_nb = lire_x_nb(buf);                //calcul du nombre de paramtres
  else par_nb=0;  
  if(par_nb<0){ //erreur
      fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - erreur pendant la lecture des paramtres\n"); 
      return(context);
      } 
  if(par_nb>0) {    
    test = lire_seq_x(buf,par_nb,&par_nom,&par);    		//lecture des paramtres
    free(buf);
    if(test!=par_nb) {						//erreur
      fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - nombre de paramtres incorrect\n");
      detruit_par(test);  
      return(context);
      } 
    }
    
  context--;
  //lecture des variables
  //*********************
  var_nb=0;
  buf = lire_balise_obl(texte,(char*)"variable");	//recherche de la balise
  if(buf!=NULL) var_nb = lire_x_nb(buf);		//calcul du nombre de variables
  if(var_nb<=0) {
    fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - pas de variables dtectes\n");    
    if(buf!=NULL) free(buf);    
    return(context);
    }         
  
  test = lire_seq_x(buf,var_nb,&var_nom,&bufs1,&var);
  
  if(test!=var_nb || this->set_var_ini(bufs1)!=1) { //erreur dans la lecture des variables
    fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - nombre de variables incorrect\n");    
    detruit_var(test);
    detruit_par();
    return(context);
    }        
  var_ini->eval(var);
    
  if(buf!=NULL) free(buf);
  for(i=0;i<var_nb;i++) if(bufs1[i]!=NULL) free(bufs1[i]); if(bufs1!=NULL) free(bufs1);
          
  context--;  
  //lecture du temps
  //****************
  buf = lire_balise(texte,(char*)"temps");
  if(buf==NULL || strcmp(buf,"continu")==0)  temps_continu=1; else temps_continu=0;
  if(buf!=NULL) free(buf);    
   
  context--;    
  //lecture du systme d'quation
  //*****************************  
  buf = lire_balise_obl(texte,(char*)"equation");   //recherche la balise equation si pas de matrice
  if(buf==NULL) {  //pas d'quations trouves
    this->detruit_var_par();
    return(context);
    }
  else {
    char* buf2 = lire_balise(texte,(char*)"matrice",&tag);  //recherche une ventuelle balise matrice
    if(buf2!=NULL) { //une balise matrice a t trouve
      free(buf);
      buf = construit_matrice(buf2,tag,var_nb);
      free(buf2);
      }
    if(tag!=NULL) free(tag);
    }
       
    //conversion de la chaine de caractres en tableau
    //stocke le nombre d'quations dans n
  bufs1 = NULL;
  n = str2tab(buf,&bufs1);         
   
    //le nombre d'quations est incorrect    
    //var_nb   -> systme d'quation standard
    //var_nb^2 -> matrice de transition
  if(n!=var_nb && n!= var_nb*var_nb) {                                       
	        fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - %d quations dtectes pour %d variables.\n",n,var_nb);
		this->detruit_var_par();
		if(bufs1!=NULL) free(bufs1); if(buf!=NULL) free(buf);
		return(context);
	    }
	       
    //le nombre d'quation est correct: construction des fonctions 
  f = new sfonction(n,var_nb,par_nb,var_nom,par_nom,var,par,bufs1);    
  if(bufs1!=NULL) free(bufs1); if(buf!=NULL) free(buf);
    
  //teste la validit des fonctions construites
  if(f->get_nb()==0) {
    	fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - quations non valides\n");
	this->detruit_var_par();	
    	return(context);
    	}
    
  //les quations dfinissent-elles une matrice de transition ?
  if(n>1 && n==var_nb*var_nb) {
    f->set_matriciel(); //les quations dcrivent une matrice de transition
    temps_continu = 0;
    }  
     
  context=0;        
  
  //lecture des isoclines
  //*********************
  n=strlen(texte);    
  buf = lire_balise(texte,(char*)"isocline",&tag);
  iso = NULL; iso_nb=0; int iso_nb2=0;
  while(buf!=NULL) {
    iso_nb2++;   //nombre de balises <isocline> lues
    if(tag==NULL || strncmp(tag,"var=",4)!=0) {
        context++;
    	fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - balise <isocline var=x> incomplte\n");
	}
    else { 
    	i = recherche_nom(&(tag[4]),var_nb,var_nom);
	if(i<0||i>=var_nb) {
		context++;
		fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - balise <isocline var=x> fait rfrence  une variable %s inconnue\n",&(tag[4]));
		}
	else {
    		int var_const = i;
		n = str22tab(buf,&bufs1,&bufs2); //n : nombre d'quations dtectes
    
    		if(iso_nb==0) iso =(isocline**) malloc(n*sizeof(isocline*));
    		else          iso =(isocline**) realloc(iso,(iso_nb+n)*sizeof(isocline*));
      
    		for(i=0;i<n;i++) {
      			int var_dep = recherche_nom(bufs1[i],var_nb,var_nom);
      			if(var_dep==-1) {
        			context++;
      				fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - variable %s inconnue\n",bufs1[i]);
				fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - l'isocline %d n'a pu tre lu\n",iso_nb2);
				iso_nb--;
				iso =(isocline**) realloc(iso,(iso_nb+n)*sizeof(isocline*));
				}
      			else {
      				iso[iso_nb+i] = NULL;
				iso[iso_nb+i] = new isocline(var_const,var_dep,var_nb,par_nb,var_nom,par_nom,var,par,bufs2[i]);
      				if(iso[iso_nb+i]->get_y()->get_nb() ==0) {
	        			context++;
      					fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - l'isocline %d n'a pu tre lu\n",iso_nb2);
					delete iso[iso_nb+i];
					iso_nb--;
					iso =(isocline**) realloc(iso,(iso_nb+n)*sizeof(isocline*));
					}
      				}
      			}
    		iso_nb+=n;
    		free(bufs1); free(bufs2);
    		}
   	}       
	free(buf); buf=NULL;
	if(tag!=NULL) free(tag); tag=NULL;  
	buf = lire_balise(texte,(char*)"isocline",&tag,iso_nb2);  //on passe  l'isocline suivant
  }
  if(buf!=NULL) free(buf); 
  if(tag!=NULL) free(tag);
  
  //lecture des quilibres
  //**********************
  buf = lire_balise(texte,(char*)"eq");
  eq_nb=0; int eq_nb2=0;
  while(buf!=NULL) {
    //tag=(char*)malloc(strlen(buf)*sizeof(char));
    char* buf2 = lire_balise(buf,(char*)"matrice",&tag);  //recherche une ventuelle balise matrice
    if(buf2!=NULL) { //une balise matrice a t trouve
      free(buf);
      buf = construit_matrice(buf2,tag,var_nb);
      free(buf2); if(tag!=NULL) free(tag);
      }
      
    eq_nb2++;                //nombre de balises <equilibe> lues
    n = str2tab(buf,&bufs1); //n : nombre d'quations dtectes
    if(n!=var_nb) {
        context++;
    	fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - l'quilibre %d a %d coordonnes dans un modle  %d variables\n",eq_nb,n,var_nb);
    	}
    else {
    
    	eq_nb++;
    	if(eq_nb==1) eq = (fonction**) malloc(eq_nb*sizeof(fonction*));
    	else         eq = (fonction**) realloc(eq,eq_nb*sizeof(fonction*));
	eq[eq_nb-1] = new fonction(var_nb,var_nb,par_nb,var_nom,par_nom,var,par,bufs1);
    	free(bufs1); free(buf);
	//retire le point d'quilibre si problme  la compilation
    	if(eq[eq_nb-1]->get_nb()==0) {
      		context++;
      		fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - impossible de lire l'quilibre %d\n",eq_nb);      
      		eq_nb--;
      		eq = (fonction**) realloc(eq,eq_nb*sizeof(fonction*));
      		}
		
	}
    buf = lire_balise(texte,(char*)"eq",eq_nb2);
    };
  
  //lecture de la matrice Jacobienne
  //********************************
  jacob=NULL;
  buf = lire_balise(texte,(char*)"jacobienne");
    
  if(buf!=NULL) {
    //tag=(char*)malloc(strlen(buf)*sizeof(char));
    char* buf2 = lire_balise(buf,(char*)"matrice",&tag);  //recherche une ventuelle balise matrice
    if(buf2!=NULL) { //une balise matrice a t trouve
      free(buf);
      buf = construit_matrice(buf2,tag,var_nb);
      free(buf2); if(tag!=NULL) free(tag);
      }    
    
    n = str2tab(buf,&bufs1);
    if(n!=var_nb*var_nb) {
    	context++;
	fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - la matrice jacobienne n'est pas de dimension %dX%d\n",var_nb,var_nb);
    	}
    else {
        jacob = (fonction**) malloc(var_nb*sizeof(fonction*));
	for(i=0;i<var_nb;i++) {
		jacob[i] = new fonction(var_nb,var_nb,par_nb,var_nom,par_nom,var,par,&(bufs1[i*var_nb]));
      		//dtruit la jacobienne si problme  la lecture
      		if(jacob[i]->get_nb()==0) {
        		context++;
			fprintf(FICHIER_SORTIE,"ERREUR modele::ouvrir_modele - impossible de lire la ligne %d de la jacobienne\n",i+1);
        		while(i>=0) {delete jacob[i]; i--;}
        		jacob=NULL;
        		break; //on sort de la boucle
        		}
      		}
	}
   free(bufs1); free(buf);
   }
  
  //lecture des caractristiques stochastiques
  //******************************************
  distribution** var_dist = (distribution**) malloc(var_nb*sizeof(distribution*));
  for(i=0;i<var_nb;i++) var_dist[i] = NULL;  
  distribution** par_dist = (distribution**) malloc(par_nb*sizeof(distribution*));
  for(i=0;i<par_nb;i++) par_dist[i] = NULL;  
     
  tag = NULL;
  buf = lire_balise(texte,(char*)"distribution",&tag);
  
  int nb_stoch = 0; //nombre de balises stochastiques lues  
  while(buf!=NULL) {
  	nb_stoch++;
	if(tag!=NULL && strncmp(tag,"var=",4)==0) { //une variable est stochastique
		i = lire_distribution(tag,buf,var_nb,var_nom,var_dist);
		if(i>=0 && i<var_nb) {
		  if(f->is_var_dep(&(var[i]))==1) f->set_var_stochastique(1);
                  var_ini->set_var_stochastique(1);
		  }
		}
	if(tag!=NULL && strncmp(tag,"par=",4)==0) { //un paramtre est stochastique
		i = lire_distribution(tag,buf,par_nb,par_nom,par_dist);
		if(i>=0 && i<par_nb) {
		  if(f->is_var_dep((&par[i]))==1) f->set_par_stochastique(1);
		  var_ini->set_par_stochastique(1);
		  }
		}
	if(i<0) context++; //problme  la lecture
	
	//lecture de la balise <stochastique> suivante
	free(buf); if(tag!=NULL) free(tag);
	buf = lire_balise(texte,(char*)"distribution",&tag,nb_stoch);
	}
  
  if(buf!=NULL) free(buf); if(tag!=NULL) free(tag); 
  
  f->set_var_dist(var_dist); 
  f->set_par_dist(par_dist);
  var_ini->set_var_dist(var_dist); 
  var_ini->set_par_dist(par_dist);
  
  if(f->stochastique() && temps_continu==1) {
    fprintf(FICHIER_SORTIE,"AVERTISSEMENT modele::ouvrir_modele - le systeme d'quation est stochastique ; le temps sera considr comme discret\n");
    temps_continu=0;
    }  
  
  //trajectoires
  //************
  tr_nb=0; tr=NULL;
  
  if(texte!=NULL) free(texte);
  return(context);
  }
//******************************************************************************************************************

modele::modele(FILE* fichier) {
  description = NULL;
  var_nb = 0; par_nb = 0;
  var = NULL; par = NULL;
  var_nom = NULL; par_nom = NULL;  
  var_ini = NULL;
   
  f = NULL;
        
  eq_nb = 0; eq = NULL;
  iso_nb = 0; iso = NULL;
  jacob = NULL;    
  tr_nb = 0; tr = NULL;
  
  char*  texte=NULL;
  MODELE_ERREUR_LECTURE = 0;
  if(lire_texte(fichier,&texte)==-1) {return;}
  MODELE_ERREUR_LECTURE = ouvrir_modele(texte);
  if(MODELE_ERREUR_LECTURE<0) {free(texte); return;}
  free(texte);
  }
  
modele::modele(char* texte) {
    description = NULL;
    var_nb = 0; par_nb = 0;
    var = NULL; par = NULL;
    var_nom = NULL; par_nom = NULL;
    
    var_ini = NULL;
    
    f = NULL;
        
    eq_nb = 0; eq = NULL;
    iso_nb = 0; iso = NULL;
    jacob = NULL;    
    tr_nb = 0; tr = NULL;
      
    MODELE_ERREUR_LECTURE = ouvrir_modele(texte);
    if(MODELE_ERREUR_LECTURE<0) return;
  }

void modele::detruit_var()
{   
  if(var_nom!=NULL) {
    for(int i=0;i<var_nb;i++) if(var_nom[i]!=NULL) free(var_nom[i]); 
    free(var_nom); var_nom=NULL;
    }
  if(var!=NULL) {free(var); var=NULL;};
  if(var_ini!=NULL) {
    delete var_ini;
    var_ini = NULL;
    }
  var_nb=0;
}

void modele::detruit_var(int n)
{  
  if(var_nom!=NULL) {
    for(int i=0;i<var_nb;i++) if(i<n && var_nom[i]!=NULL) free(var_nom[i]);
    free(var_nom); var_nom=NULL;
    }  
  if(var!=NULL) {free(var); var=NULL;};
  if(var_ini!=NULL) {
    delete var_ini; 
    var_ini = NULL;
    }
  var_nb=0;
}

void modele::detruit_par()
{  
  if(par_nom != NULL) {
    for(int i=0;i<par_nb;i++) if(par_nom[i]!=NULL) free(par_nom[i]); 
    free(par_nom); par_nom = NULL;
    }
  if(par!=NULL) {free(par); par=NULL;}
  par_nb=0;
}

void modele::detruit_par(int n)
{  
  if(par_nom != NULL) {
    for(int i=0;i<par_nb;i++) if(i<n && par_nom[i]!=NULL) free(par_nom[i]); 
    free(par_nom); par_nom = NULL;
    }
  if(par!=NULL) {free(par); par=NULL;}
  par_nb=0;  
}

void modele::detruit_var_par()
{
  this->detruit_var();
  this->detruit_par(); 
}
  
void modele::detruit() { 
  if(tr_nb>0) {
    for(int i=0;i<tr_nb;i++) delete tr[i];
    free(tr); tr=NULL;
    tr_nb=0;
    }

  if(eq_nb>0) {
    for(int i=0;i<eq_nb;i++)
      delete eq[i];
    free(eq); eq=NULL;
    eq_nb=0;
    }

  if(jacob!=NULL) {
    for(int i=0;i<var_nb;i++) {
      delete jacob[i];
      }
    free(jacob);
    jacob=NULL;
    }
  
  if(description!=NULL) free(description);
    
  temps_continu=1;
  //f et var_ini partagent les mme distributions
  //on free les distribution dans var_ini et on dtruit le lien dans f
  if(f!=NULL) {
    f->set_par_dist(NULL); f->set_var_dist(NULL);
    delete f; f=NULL;
    }  
  detruit_var_par();
  }

modele::~modele() {
  detruit();
  }  

//routines de base------------------------------------------------
//----------------------------------------------------------------
//teste la validit du modle
int modele::valide() {  
  if(var_nb==0 || f==NULL || f->get_nb()==0) return(false);
  return(true);
  }
    
void modele::ecrire() {
  if(!valide()) return;
  if(description!=NULL) fprintf(FICHIER_SORTIE,"%s\n",description);
  fprintf(FICHIER_SORTIE,"Variables :\n");
  ecrire_variable();
  fprintf(FICHIER_SORTIE,"Paramtres :\n");  
  ecrire_parametre();
  fprintf(FICHIER_SORTIE,"Equations :\n");
  f->ecrire();     
  if(iso_nb>0) {
    fprintf(FICHIER_SORTIE,"Isoclines :\n");
    for(int i=0;i<iso_nb;i++) {      
      int j=iso[i]->get_var_const();
      int k=iso[i]->get_var_dep();
      fprintf(FICHIER_SORTIE,"%s : %s=",var_nom[j],var_nom[k]);
      iso[i]->get_y()->ecrire(); 
      }
    }
  if(eq_nb>0) {
    fprintf(FICHIER_SORTIE,"quilibres :\n");
    for(int i=0;i<eq_nb;i++) {
      eq[i]->ecrire('\t'); fprintf(FICHIER_SORTIE,"\n");
      }
    }
  if(jacob!=NULL) {
    fprintf(FICHIER_SORTIE,"Matrice jacobienne :\n");
    for(int i=0;i<var_nb;i++) {
      jacob[i]->ecrire('\t'); fprintf(FICHIER_SORTIE,"\n");
      }
    }
  }


char* modele::get_description() {
  return(description);
  };

int modele::get_temps_continu() {
  return(temps_continu);
  };   
  
//gestion des paramtres et des variables------------------------
//---------------------------------------------------------------
void modele::variable(double* v) {
  for(int i=0;i<var_nb;i++) var[i] = v[i];
  }
  
void modele::parametre(double* v) {
  for(int i=0;i<par_nb;i++) par[i] = v[i];
  }

void modele::variable(int i,double x) {
  var[i] = x;
  }

void modele::parametre(int i,double x) {
  par[i] = x;
  }
    
void modele::ecrire_parametre() {
  for(int i=0;i<par_nb;i++) fprintf(FICHIER_SORTIE,"%s = %g\n",par_nom[i],par[i]);
  }

void modele::ecrire_variable() {
  var_ini->ecrire(var_nom);   
  }

int modele::get_var_nb() {
  return(var_nb);
  }

int modele::get_par_nb() {
  return(par_nb);
  }    

double* modele::get_var() {
  return(var);
  }

double* modele::get_par() {
  return(par);
  }
      
double modele::get_var(int i) {
  return(var[i]);
  }

double modele::get_par(int i) {
  return(par[i]);
  }

char** modele::get_var_nom() {
  return(var_nom);
  }

char** modele::get_par_nom() {
  return(par_nom);
  }
      
char* modele::get_var_nom(int i) {
  return(var_nom[i]);
  }

char* modele::get_par_nom(int i) {
  return(par_nom[i]);
  }

void modele::set_temps_continu(int i) {
  if(i==0) temps_continu = 0; else temps_continu=1;
  }  

void modele::set_var(int i,double x) {
if(i>=0 && i<var_nb) var[i]=x;
}
void modele::set_par(int i,double x){
if(i>=0 && i<par_nb) par[i]=x;
}
void modele::set_var(double* x) {
for(int i=0;i<var_nb;i++) var[i]=x[i];
}
void modele::set_par(double* x){
for(int i=0;i<par_nb;i++) par[i]=x[i];
}
                                                                                                
//gestion des quilibres-----------------------------------------
//---------------------------------------------------------------
int modele::get_eq_nb() {
  return(eq_nb);
  }
  
fonction* modele::get_eq(int i) {
  if(i<eq_nb) return(eq[i]);
  else return(NULL);
  }
  
void modele::ecrire_equilibre() {
  for(int i=0;i<eq_nb;i++) {
    for(int j=0;j<var_nb;j++) {
      double x;
      if(eq[i]->eval(&x)==1) fprintf(FICHIER_SORTIE,"%g\t",x);
      else                   fprintf(FICHIER_SORTIE,"nan\t");
      }
    if(jacob==NULL) fprintf(FICHIER_SORTIE,"\n");
    else fprintf(FICHIER_SORTIE,"%d\n",stable(eq[i]));
    }
  }

void modele::ecrire_equilibre(FILE* fichier) {
  double** x = (double**)malloc(eq_nb*sizeof(double*));
  for(int i=0;i<eq_nb;i++) {
    x[i] = (double*) malloc(var_nb*sizeof(double));
    eq[i]->eval(x[i]);
    }
    
  for(int i=0;i<eq_nb;i++) {    
    for(int j=0;j<var_nb;j++) fprintf(fichier,"%g\t",x[i][j]);            
    if(jacob==NULL) fprintf(fichier,"\n");
    else fprintf(fichier,"%d\n",stable(x[i]));
    free(x[i]);
    }
  free(x);
  }
  
//dtermine la stabilit d'un quilibre   partir de la Jacobienne
//retourne 1 si l'quilibre est stable, -1 s'il est instable et 0 en cas de doute
//la valeur de retour est multiplie par deux si les parties imaginaires sont non nulle
extern double LIMITE_PRECISION_VP; //prcision dans les calculs de valeur propre
int modele::stable(fonction* eq) {
  //vrification du nombre de variables
  if(eq->get_nb()!=var_nb) return(0);

  
  //value le point d'quilibre et le stocke dans x
  double* x = (double*)malloc(var_nb*sizeof(double));
  if(eq->fonction::eval(NULL,x)==-1) return(-1);
  
  //teste la stabilit
  int test = this->stable(x);
  
  return(test);         
  }

int modele::stable(double* x) {
  int i,j;

  //for(i=0;i<var_nb;i++) printf("%g ",x[i]); printf("\n");

  //calcule la jacobienne en x et la stocke dans mj
  double** mj=(double**) malloc(var_nb*sizeof(double*));
  for(i=0;i<var_nb;i++) mj[i] = (double*) malloc(var_nb*sizeof(double));  
  for(i=0;i<var_nb;i++) {
  	if(jacob[i]->fonction::eval(x,mj[i])==-1)   {
		fprintf(FICHIER_SORTIE,"KSimPop model::stable - erreur dans le calcul de la Jacobienne.\n");
		for(i=0;i<var_nb;i++) free(mj[i]); free(mj);
		return(-1);
		}
	}

  //calcul des valeurs propres
  float*  vp_r = (float*) malloc((var_nb+1)*sizeof(float));
  float*  vp_i = (float*) malloc((var_nb+1)*sizeof(float));
  float** m=(float**) malloc((var_nb+1)*sizeof(float*));
  for(i=1;i<=var_nb;i++) m[i] = (float*) malloc((var_nb+1)*sizeof(float));
  for(i=1;i<=var_nb;i++) {
    for(j=1;j<=var_nb;j++) {
      m[i][j]=mj[i-1][j-1];
      }
    }  
  for(i=0;i<var_nb;i++) free(mj[i]); free(mj);  
  elmhes(m,var_nb);
  hqr(m,var_nb,vp_r,vp_i);

  //for(j=0;j<=var_nb;j++) printf("%g + i*%g\n",vp_r[j],vp_i[j]); printf("\n"); fflush(stdout);

  int    stable = 0;     
  if(temps_continu==1) { //temps continu
        //cherche la valeur propre dominante
        double lead_pr= vp_r[1];
	double lead_pi= vp_i[1];
        for(i=2;i<=var_nb;i++) {
	  double z = vp_r[i];
	  if(z>lead_pr) {
	    lead_pr=vp_r[i];
	    lead_pi=vp_i[i];
	    }
	  }
  	//affiche vp dominante si elle est dans les limites de prcision
  	if(fabs(lead_pr)<=LIMITE_PRECISION_VP) {
  	  fprintf(FICHIER_SORTIE,"KSimPop model::stable - valeur propre dans les limites de prcision\n");
  	  for(i=0;i<var_nb;i++) fprintf(FICHIER_SORTIE,"%s=%g ",var_nom[i],x[i]);
  	  fprintf(FICHIER_SORTIE,"vp_max=%g\n",lead_pr);
	  stable=3;
  	  }
	//dtermine la stabilit	
	else {
	  if(lead_pr<LIMITE_PRECISION_VP) stable = 2; //stable
	  else stable=1;                              //instable
	  }
	//dtermine le comportement oscillatoire  
	if(fabs(lead_pi)>LIMITE_PRECISION_VP) stable*=-1;
  }
  else {  //temps discret
  	double lead_mod= sqrt(pow(vp_r[1],2.0)+pow(vp_i[1],2.0));
	double lead_pi= vp_i[1];
	for(i=2;i<=var_nb;i++) {
	  double z = sqrt(pow(vp_r[i],2.0)+pow(vp_i[i],2.0));
	  if(z>lead_mod) {
	    lead_mod=z;
	    lead_pi=vp_i[i];
	    }
	  }
	//affiche vp dominante si elle est dans les limite de prcision
  	if(fabs(fabs(lead_mod)-1.0)<=LIMITE_PRECISION_VP) {
  	  fprintf(FICHIER_SORTIE,"KSimPop model::stable - valeur propre dans les limites de prcision\n");
  	  for(i=0;i<var_nb;i++) fprintf(FICHIER_SORTIE,"%s=%g ",var_nom[i],x[i]);
  	  fprintf(FICHIER_SORTIE,"vp_max=%g\n",lead_mod);
	  stable = 3;
          }
	//dtermine la stabilit
	else {
	  if(fabs(lead_mod)<1+LIMITE_PRECISION_VP) stable = 2;
	  else stable = 1;
	  }
	//dtermine le comportement oscillatoire  
	if(fabs(lead_pi)>LIMITE_PRECISION_VP) stable*=-1;
	}
	
  //libre la mmoire alloue
  free(vp_r);
  free(vp_i);
  for(i=1;i<=var_nb;i++) {free(m[i]);}
  free(m);
  
  return(stable);
  }    
//gestion des trajectoires---------------------------------------
//---------------------------------------------------------------
//stoppe le calcul d'une trajectoire
void modele::stop() {
  f->stop();
  } 
//renvoit le nombe de trajectoires
int modele::get_tr_nb() {
  return(tr_nb);
  }
  
//ajout de trajectoires***************************************************
//ajout d'une trajectoire  partir du point courant sans prciser le nombre de points stocks
void modele::ajout_trajectoire(double tmax) {
  if(!valide()) return; //pas de fonction charge  
  
  if(var_ini!=NULL) var_ini->eval(var);  
    
  double** v;
  int pt_nb;
  if(temps_continu==1) v = f->dynamique_c(tmax,&pt_nb);
  else                 v = f->dynamique_d(tmax,&pt_nb);

  tr_nb++;
  if(tr_nb>1) tr = (trajectoire**) realloc(tr,tr_nb*sizeof(trajectoire*));
  else        tr = (trajectoire**) malloc(tr_nb*sizeof(trajectoire*));
  tr[tr_nb-1] = new trajectoire(var_nb,pt_nb,v);    
  }
    
//rafraichir des trajectoires**********************************************
//rafraichit la trajectoire i  en fixant le temps de simulation  tmax
void modele::rafraichir_trajectoire(int i,double tmax) {
  if(!valide()) return; //pas de fonction charge

  if(i>=tr_nb) {
    fprintf(FICHIER_SORTIE,"ERREUR modele::rafraichir_trajectoire - trajectoire %d sur %d demande\n",i,tr_nb);
    return;
    }

  double* x=(double*) malloc(var_nb*sizeof(double));

  //rcupre les paramtres de la trajectoire
  tr[i]->get_ini(x);                                      //conditions initiales

  double** v = tr[i]->get_v();
  int k;

  //libre la mmoire alloue
  for(k=0;k<tr[i]->get_pt_nb();k++) free(v[k]); free(v);

  if(temps_continu==1)  {        
        tr[i]->set_v(f->dynamique_c(tmax,&k,x));
        tr[i]->set_pt_nb(k);
        }
  else  {        
        tr[i]->set_v(f->dynamique_d(tmax,&k,x));
        tr[i]->set_pt_nb(k);
        }  
  free(x);
  }

//rafraichit la trajectoire i  reprenant le temps de simulation  tmax  
void modele::rafraichir_trajectoire(int i) {
  rafraichir_trajectoire(i,tr[i]->get_tmax());
  }
  
//rafraichit toutes les trajectoires en changeant tmax
void modele::rafraichir_trajectoire(double tmax) {  
  if(!valide()) return; //pas de fonction charge
  for(int i=0;i<tr_nb;i++) rafraichir_trajectoire(i,tmax);  
  }  
  
//rafraichit toutes les trajectoires sans changer tmax  
void modele::rafraichir_trajectoire() {  
  if(!valide()) return; //pas de fonction charge
  for(int i=0;i<tr_nb;i++) rafraichir_trajectoire(i);  
  }       
  
//effacer des trajectoires**********************************************
//efface la trajectoire i
void modele::suppr_trajectoire(int i) {
  if(i<0 || i>=tr_nb) return;
  delete tr[i];
  for(int j=i;j<tr_nb-1;j++) tr[j]=tr[j+1];
  tr_nb--;
  tr = (trajectoire**) realloc(tr,tr_nb*sizeof(trajectoire*));  
  }
//efface toutes les trajectoires
void modele::suppr_trajectoire() {  
  for(int i=0;i<tr_nb;i++) delete tr[i];
  free(tr); tr=NULL;
  tr_nb=0;
  }



//affecte une trajectoire  la trajectoire i
void modele::set_trajectoire(int i,trajectoire* t){
  if(i<0 || i>=tr_nb) return;
  delete tr[i];
  tr[i]=t;
  }
              
//crit la trajectoire i
void modele::ecrire_trajectoire(int i){
  tr[i]->ecrire();
  }

//crit les trajectoires
void modele::ecrire_trajectoire(){
  for(int i=0;i<tr_nb;i++) {
    fprintf(FICHIER_SORTIE,"Trajectoire %d :\n",i);
    tr[i]->ecrire(FICHIER_SORTIE);
    }
  }

//crit les trajectoires dans un fichier
void modele::ecrire_trajectoire(FILE* fichier){
  if(tr_nb<=0) return;
  int i,j;
  //calcule le nombre de points maximum
  int max_pt_nb=0;
  for(i=0;i<tr_nb;i++) {
    j=tr[i]->get_pt_nb();
    if(j>max_pt_nb) max_pt_nb=j;
    }
    
  for(j=0;j<max_pt_nb;j++) {  
    for(int i=0;i<tr_nb-1;i++)   tr[i]->ecrire(fichier,j,'\t');
    tr[tr_nb-1]->ecrire(fichier,j,'\n');
    }
  }
  
void modele::ecrire_trajectoire_sans_t(FILE* fichier){
  if(tr_nb<=0) return;
  int i,j;
  //calcule le nombre de points maximum
  int max_pt_nb=0;
  for(i=0;i<tr_nb;i++) {
    j=tr[i]->get_pt_nb();
    if(j>max_pt_nb) max_pt_nb=j;
    }
    
  for(j=0;j<max_pt_nb;j++) {  
    for(int i=0;i<tr_nb-1;i++)   tr[i]->ecrire_sans_t(fichier,j,'\t');
    tr[tr_nb-1]->ecrire_sans_t(fichier,j,'\n');
    }
  }  

void modele::ecrire_trajectoire_un_t(FILE* fichier){
  if(tr_nb<=0) return;
  int i,j;
  //calcule le nombre de points maximum
  int max_pt_nb=0;
  for(i=0;i<tr_nb;i++) {
    j=tr[i]->get_pt_nb();
    if(j>max_pt_nb) max_pt_nb=j;
    }
    
  for(j=0;j<max_pt_nb;j++) {
    if(tr_nb>1) {
      tr[0]->ecrire(fichier,j,'\t');
      for(int i=1;i<tr_nb-1;i++)
        tr[i]->ecrire_sans_t(fichier,j,'\t');
      tr[tr_nb-1]->ecrire_sans_t(fichier,j,'\n');
      }
    else tr[0]->ecrire(fichier,j,'\n');
    }
  }
            
//renvoit la trajectoire i
trajectoire* modele::get_trajectoire(int i){
  if(i<0 || i>= tr_nb) return(NULL);
  return(tr[i]);
  }
    

//gestion des isoclines------------------------------------------
//---------------------------------------------------------------
int modele::get_iso_nb() {
  return(iso_nb);
  }
  
isocline* modele::get_iso(int i) {
  return(iso[i]);
  }

void modele::ecrire_isocline(char* nom,double xmax,double ymax) {
  FILE* fichier;
  
  for(int i=0;i<iso_nb;i++) {
    char* buf = (char*) malloc((strlen(nom)+5)*sizeof(char));
    sprintf(buf,"%s.%d",nom,i);
    fichier = fopen(buf,"w");
    if(fichier==NULL) {
      fprintf(FICHIER_SORTIE,"ERREUR modele::ecrire_gnuplot - impossible d'crire dans %s.iso.%d\n",nom,i);
      return;
      };
    
    //if(strcmp(iso[i]->get_x_nom(),var_nom[0])==0)
    if(iso[i]->get_var_dep()==0)
      iso[i]->ecrire(fichier,xmax);
    else
      iso[i]->ecrire(fichier,ymax);

    fclose(fichier);
    }        
  }
//gestion de la jacobienne---------------------------------------
//---------------------------------------------------------------
fonction** modele::get_jacob() {
  return(jacob);
  }

      
