/***************************************************************************
 *   Copyright (C) 2005 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef OBJET_H
#define OBJET_H

#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "specification_fonction.h"
#include "parseur.h"

//classe de  base pour la construction de fonction
//types d'objet:
//  n               oprateur nul
//  v               constante, oprateur sans oprande
//  o               oprateurs  deux oprandes * + - / ^ 
//  f               fonction
//  t               template : chaine de caractres o les lments prcds d'un & sont  interprter  la compilation

class objet {
  public:
    objet();                 //constructeur de base    
    objet(char c,char* s);   //type c nom s
    objet(double z);         //type 'c' (constante) valeur z
    ~objet();                //destructeur    

    
    //oprations courante
    char    get_t() {return(t);};
    char*   get_nom() {return(nom);};
    double  get_x() {return(x);};
    double* get_lx() {return(lx);};
    
    void   set_t(char z) {t=z;};
    void   set_x(double z) {x=z;};
    void   set_lx(double *z) {lx=z;};
    void   set_lo(objet *z) {lo=z;};
    int    set_nom(char* s);
            
    int    is_var_dep(double* x);
    int    cherche_x(int z_nb,char** z_nom); 
        
    int    lire(char* s);
    char*  concatene(char** s);
    void   ecrire();    
    char*  tostring();
               
    int    construit_indice(char*** nom_i,int** val_i,int** val_max,int** val_min);
    
    void   erreur_syntaxe();
    
    double eval();                                                           //valuation standard    
    int    eval(int var_nb,int nb_i,char** nom_i,int* val_min,int* val_max);  //valuation des liste de valeurs d'indice
                            
  private:      
    char*   nom;   //nom (notamment pour les paramtres et les variables)    
    char    t;     //type d'oprateur
    double* lx;    //pointeur vers une variable ou un parametre
    double  x;     //constante
    objet   *lo;   //pointeur vers un objet         
  };

//routine de cration et de traitement des chaines d'objets    
int lire_chaine_objet(char* s,objet*** chaine_objet,int var_nb,char** var_nom,double* var,int par_nb,char** par_nom,double* par);
void detruit_chaine_objet(int n,objet** chaine_objet);
int nombre_arguments(objet** chaine,int n);
int parenthese_fermante(objet** chaine,int n);
int longueur_argument(objet** chaine,int n,int nb);

#endif
