/***************************************************************************
 *   Copyright (C) 2005 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 #ifndef OPERATION_SIMPLE_H
 #define OPERATION_SIMPLE_H

 #include "objet.h"
 #include "operation_base.h"
 
 class operationSimple : public operationBase { //: public operation_base
  public:
    //constructeurs
    //**********************************************************
    operationSimple();                  //opration vide n=2
    operationSimple(int nb);            //opration vide n=nb
    operationSimple(int nb,char c);     //opration de type c  nb arguments. La fonction d'valuation est affecte.
     
                                        //constructeur compilateur
    operationSimple(objet** chaine,int n,int var_nb,char** var_nom,double* var,int par_nb,char** par_nom,double* par);
    
    void cp(operationSimple* o);        //copie les membes de l'opration o
    
    //destructeur
    //**********************************************************
    virtual ~operationSimple();                                            
    
    //routines hrites de operation_base
    //**********************************************************
    int    get_nb_op();                                      
    int    is_var_dep(double* xx);                
    void   set_n(int i);                                 
    int    eval_argument();
    
    //routines d'criture
    //**********************************************************    
    char*  tostring();
    
    //routines de base non hrites           
    //**********************************************************
    void set_pere(operationSimple* o) 
      {pere=o;};      
    operationSimple*  get_pere()    
      {return(pere);};
    operationSimple*  get_op(int i) 
      {if(i>-1&&i<n) return(op[i]); return(NULL);};
    //affecter des arguments*********
    int    set_o(double z)
      {int i=0;
       while(i<n) {if(ob[i]==NULL && op[i]==NULL) {ob[i]= new objet(z); return(1);}; i++;}
       return(-1);
       };
    int    set_o(objet* o)
      {int i=0;
       while(i<n) {if(ob[i]==NULL && op[i]==NULL) {ob[i]=o; return(1);}; i++;}
       return(-1);
       };
    int    set_o(operationSimple* o)
      {int i=0;
       while(i<n) {if(ob[i]==NULL && op[i]==NULL) {op[i]=o; if(o!=NULL) o->set_pere(this); return(1);}; i++;}
       return(-1);
       };
    int    set_o(int i,operationSimple* o)  
      {if(i<n) {op[i]=o; if(o!=NULL) o->set_pere(this); return(1);} else return(-1);};
    int    set_o(int i,objet* o) 
      {if(i<n) {ob[i]=o; return(1);} else return(-1);};
    //raffecter des arguments*********          
    void   reset_o(objet* o)
      {ob[n-1]=o; op[n-1]=NULL;};
    void   reset_o(operationSimple* o)
      {op[n-1]=o; if(o!=NULL) o->set_pere(this); ob[n-1]=NULL;};
    void   reset_ob(int i,objet* o)
      {if(i>-1 && i<n) {ob[i]=o; op[i]=NULL;}};
    void   reset_op(int i,operationSimple* o)
      {if(i>-1 && i<n) {op[i]=o; if(o!=NULL) o->set_pere(this); ob[i]=NULL;}};   
                                          
  private :
    operationSimple*  pere;
    operationSimple** op;       
  };      
  
  #endif
//

