/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "option.h"
#include "form_option.h"

#include "math.h"
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlineedit.h>

option::option(double MAX_FLOAT,int MAX_TEMPS_CALCUL,double ODE_PRECISION,int ODE_METHODE,double LIMITE_PRECISION_VP,QString AIDE_PATH,QString AIDE_BROWSER) : Form_option()
{
QObject::connect(pushButton_ok,SIGNAL(clicked()),this,SLOT(ok()));
QObject::connect(pushButton_annuler,SIGNAL(clicked()),this,SLOT(annuler()));

int i;

i = (int) (log(MAX_FLOAT)/log(10.0) + 0.5); 
spinBox_max_float->setValue(i);
spinBox_max_temps_calcul->setValue(MAX_TEMPS_CALCUL);
i = (int) (log(ODE_PRECISION)/log(10.0) - 0.5); 
spinBox_precision_ode->setValue(i);
i = (int) (log(LIMITE_PRECISION_VP)/log(10.0) - 0.5); 
spinBox_precision_vp->setValue(i);
lineEdit_chemin->setText(AIDE_PATH);
lineEdit_navigateur->setText(AIDE_BROWSER);

//constuction de la liste des mthodes d'intgration
comboBox_ode_methode->insertItem("Embedded Runge-Kutta (2, 3) method.");
comboBox_ode_methode->insertItem("4th order (classical) Runge-Kutta.");
comboBox_ode_methode->insertItem("Embedded Runge-Kutta-Fehlberg (4, 5) method.");
comboBox_ode_methode->insertItem("Embedded Runge-Kutta Cash-Karp (4, 5) method.");
comboBox_ode_methode->insertItem("Embedded Runge-Kutta Prince-Dormand (8,9) method.");
comboBox_ode_methode->insertItem("Implicit 2nd order Runge-Kutta at Gaussian points.");
comboBox_ode_methode->insertItem("Implicit 4th order Runge-Kutta at Gaussian points.");
comboBox_ode_methode->insertItem("M=1 implicit Gear method.");
comboBox_ode_methode->insertItem("M=2 implicit Gear method.");
if(ODE_METHODE==-1) comboBox_ode_methode->setCurrentItem(2);
else comboBox_ode_methode->setCurrentItem(ODE_METHODE);
}

void option::ok()
{accept();}

void option::annuler()
{reject();}

//#include "form_option.moc"
