/***************************************************************************
 *   Copyright (C) 2005 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "parseur.h"

extern FILE* FICHIER_SORTIE;

 //type d'un caractre
int type_caractere(char c) {
  if((c >='0' && c<='9') || c=='.')                  return(1);        //numrique
  if(c=='+' || c=='-' || c=='*' || c=='/' || c=='^') return(2);        //oprateur
  if(c==')' || c=='(' || c==',')                     return(3);        //sparateur
  if(c=='"')                                         return(4);        //template
  if(c=='{' || c=='}')                               return(5);        //indice
  if(c==' ' || c=='\t' || c=='\n' || c=='\0')        return(-1);       //caractre non trait
                                                     return(0);        //texte
  }

 void remplace_char(char* s,char c1,char c2) {
   if(s==NULL || strlen(s)<=0) return;
   int n = strlen(s);
   for(int i=0;i<n;i++) if(s[i]==c1) s[i]=c2;
   } 
     
 int recherche_nom(char* s,int nb,char** nom) { //recherche un nom dans un tableau de nom
	int i;
	for(i=0;i<nb && strcmp(nom[i],s)!=0;i++);
	if(i<nb) return(i);
	else return(-1);
	}

char* concatene(char** s1,char* s2) {  
  int n1 = 0;
  if((*s1)!=NULL && sizeof(*s1)>0) n1 = strlen(*s1);
  int n2 = 0;
  if(s2!=NULL && sizeof(s2)>0) n2 = strlen(s2);
  
  char* s = (char*) malloc((n1+n2+1)*sizeof(char));
  
  if((*s1)!=NULL && sizeof(*s1)>0) for(int i=0;i<n1;i++) s[i]=(*s1)[i];
  if(s2!=NULL && sizeof(s2)>0) for(int i=0;i<n2;i++) s[n1+i]=s2[i];
  s[n1+n2]='\0';
  if((*s1)!=NULL && sizeof(*s1)>0) free(*s1);
  return(s);
  }
  
char* concatene(char** s1,char c) {  
  int n1 = 0;
  if((*s1)!=NULL && sizeof(*s1)>0) n1 = strlen(*s1);
  char* s = (char*) malloc((n1+2)*sizeof(char));
  if((*s1)!=NULL && sizeof(*s1)>0) for(int i=0;i<n1;i++) s[i]=(*s1)[i];  
  s[n1]=c;
  s[n1+1]='\0';
  if((*s1)!=NULL && sizeof(*s1)>0) free(*s1);
  return(s);
  }

char* concatene(char** s1,int x) {  
  int n1 = 0;
  if((*s1)!=NULL && sizeof(*s1)>0) n1 = strlen(*s1);
  char* s = (char*) malloc((n1+1+24)*sizeof(char));
  if((*s1)!=NULL && sizeof(*s1)>0) for(int i=0;i<n1;i++) s[i]=(*s1)[i];  
  s[n1]='\0';
  sprintf(s,"%s%d",s,x);
  if((*s1)!=NULL && sizeof(*s1)>0) free(*s1);
  
  s = (char*) realloc(s,(strlen(s)+1)*sizeof(char));  
  return(s);
  }
      
char* concatene(char** s1,double x) {  
  int n1 = 0;
  if((*s1)!=NULL && sizeof(*s1)>0) n1 = strlen(*s1);
  char* s = (char*) malloc((n1+1+24)*sizeof(char));
  if((*s1)!=NULL && sizeof(*s1)>0) for(int i=0;i<n1;i++) s[i]=(*s1)[i];  
  s[n1]='\0';
  sprintf(s,"%s%g",s,x);
  if((*s1)!=NULL && sizeof(*s1)>0) free(*s1);
  
  s = (char*) realloc(s,(strlen(s)+1)*sizeof(char));  
  return(s);
  }

//verifie le parenthsage dans une chaine de caractres
//si le nombre renvoy n'est pas nul, il y a un pb
int parenthese(char* s) {
  if(s==NULL || sizeof(s)==0) return(0);
  
  int n = strlen(s);
  int nbp=0;
  int nbc=0;
  int nba=0;
  for(int i=0;i<n;i++) {
    if(s[i]=='(') nbp++;
    if(s[i]==')') nbp--;
    if(s[i]=='[') nbc++;
    if(s[i]==']') nbc--;
    if(s[i]=='{') nba++;
    if(s[i]=='}') nba--;
    }
    
  if(nbp<0) return('(');
  if(nbp>0) return(')');
  if(nbc<0) return('[');
  if(nbc>0) return(']');
  if(nba<0) return('{');
  if(nba>0) return('}');
  return('0');
  }
  
int str2tab(char* str,char*** tab) {        //transforme une chaine de caractre en un tableau en utilisant 
					    //les virgules, tabulation ou saut de ligne comme sparateurs
					    //renvoit le nombre de lignes du tableau cr
	if(str==NULL) return(0);
	
	int n=strlen(str);
        int i=0;
	int j=0;
	
	int nbp = 0; //nombre de parenthses
	int nbc = 0; //nombre de crochets
	int nba = 0; //nombre d'accolades
	
	while(j<n) {
		//on saute les espaces, tabulations, etc.
		while(j<n && (str[j]=='\n' || str[j]==' ' || str[j]=='\t'  || str[j]=='\0')) j++; 
		
		if(j<n) {
			if(i>0) (*tab) = (char**)realloc(*tab,(i+1)*sizeof(char*));
    			else    (*tab) = (char**)malloc((i+1)*sizeof(char*));
			(*tab)[i] = (char*) &(str[j]);
			i++;
			}
		while(j<n) {
		  if(str[j]=='(') nbp++; if(str[j]==')') nbp--;
		  if(str[j]=='[') nbc++; if(str[j]==']') nbc--;
		  if(str[j]=='{') nba++; if(str[j]=='}') nba--;
		  if(j<n-1 && nbp==0 && nbc==0 && nba==0 && (str[j]==',' || str[j]=='\n' || str[j]=='\0')) break;
		  //si fin de ligne au milieu d'une parenthse, on enlve la fin de ligne
		  if(j<n-1 && !(nbp==0 && nbc==0 && nba==0) &&(str[j]=='\0' || str[j]=='\n')) str[j]=' '; 
		  j++;
		  }
		if(j<n) str[j]='\0';
    		}
	return(i);
}

int str22tab(char* str,char*** tab1,char*** tab2) {        //transforme une chaine de caractre en deux tableaux en utilisant 
					    	           //les virgules, tabulation ou saut de ligne comme sparateurs
							   //le = spare ce qui va dans l'un ou l'autre des tableaux
					                   //renvoit le nombre de lignes du tableau cr
	if(str==NULL) return(0);
	
	int n=strlen(str);
        int i=0;
	int j=0;
	
	int nbp = 0; //nombre de parenthses
	int nbc = 0; //nombre de crochets
	int nba = 0; //nombre d'accolades
		
	while(j<n) {
		//on saute les espaces, tabulations, etc.
		while(j<n && (str[j]=='\n' || str[j]==' ' || str[j]=='\t'  || str[j]=='\0')) j++; 
		if(j<n) {
			if(i>0) {
				*tab1 = (char**)realloc(*tab1,(i+1)*sizeof(char*));
				*tab2 = (char**)realloc(*tab2,(i+1)*sizeof(char*));
				}
    			else    {
				*tab1 = (char**)malloc((i+1)*sizeof(char*));
				*tab2 = (char**)malloc((i+1)*sizeof(char*));
				}
				
			(*tab1)[i]=&(str[j]);
			
			while(j<n && str[j]!='=') j++;	//on cherche le =
			int k = j-1; //on se place juste avant le =
			while(k>=0 && (str[k]=='\n' || str[k]==' ' || str[k]=='\t'  || str[k]=='\0')) k--; //on recule tant qu'il y a des espaces, etc.
			k++; if(k>=0 && k<n) str[k]='\0'; 
			j++; //on se place juste aprs le =
			while(j<n && (str[j]=='\n' || str[j]==' ' || str[j]=='\t'  || str[j]=='\0')) j++; //on avance tant qu'il y a des espaces, etc.
			
			(*tab2)[i]=&(str[j]);
			i++;
			}
		while(j<n) {
		  if(str[j]=='(') nbp++; if(str[j]==')') nbp--;
		  if(str[j]=='[') nbc++; if(str[j]==']') nbc--;
		  if(str[j]=='{') nba++; if(str[j]=='}') nba--;
		  if(j<n-1 && nbp==0 && nbc==0 && nba==0 && (str[j]==',' || str[j]=='\n' || str[j]=='\0')) break;
		  //si fin de ligne au milieu d'une parenthse, on enlve la fin de ligne
		  if(j<n-1 && !(nbp==0 && nbc==0 && nba==0) &&(str[j]=='\0' || str[j]=='\n')) str[j]=' ';
		  j++;
		  }
		if(j<n) str[j]='\0';
    		}
	return(i);
}

int str22tab(char* str,char*** tab1,char*** tab2,char sep) {        //transforme une chaine de caractre en deux tableaux en utilisant 
					    	           //les virgules, tabulation ou saut de ligne comme sparateurs
							   //le = spare ce qui va dans l'un ou l'autre des tableaux
					                   //renvoit le nombre de lignes du tableau cr
	if(str==NULL) return(0);
	
	int n=strlen(str);
        int i=0;
	int j=0;
	
	int nbp = 0; //nombre de parenthses
	int nbc = 0; //nombre de crochets
	int nba = 0; //nombre d'accolades
		
	while(j<n) {
		//on saute les espaces, tabulations, etc.
		while(j<n && (str[j]=='\n' || str[j]==' ' || str[j]=='\t'  || str[j]=='\0')) j++; 
		if(j<n) {
			if(i>0) {
				*tab1 = (char**)realloc(*tab1,(i+1)*sizeof(char*));
				*tab2 = (char**)realloc(*tab2,(i+1)*sizeof(char*));
				}
    			else    {
				*tab1 = (char**)malloc((i+1)*sizeof(char*));
				*tab2 = (char**)malloc((i+1)*sizeof(char*));
				}
				
			(*tab1)[i]=&(str[j]);
			
			while(j<n && str[j]!='=') j++;	//on cherche le =
			int k = j-1; //on se place juste avant le =
			while(k>=0 && (str[k]=='\n' || str[k]==' ' || str[k]=='\t'  || str[k]=='\0')) k--; //on recule tant qu'il y a des espaces, etc.
			k++; if(k>=0 && k<n) str[k]='\0'; 
			j++; //on se place juste aprs le =
			while(j<n && (str[j]=='\n' || str[j]==' ' || str[j]=='\t'  || str[j]=='\0')) j++; //on avance tant qu'il y a des espaces, etc.
			
			(*tab2)[i]=&(str[j]);
			i++;
			}
		while(j<n) {
		  if(str[j]=='(') nbp++; if(str[j]==')') nbp--;
		  if(str[j]=='[') nbc++; if(str[j]==']') nbc--;
		  if(str[j]=='{') nba++; if(str[j]=='}') nba--;
		  if(j<n-1 && nbp==0 && nbc==0 && nba==0 && str[j]==sep) break;
		  //si sparateur au milieu d'une parenthse, on enlve la fin de ligne
		  if(j<n-1 && !(nbp==0 && nbc==0 && nba==0) && str[j]==sep) {
		    if(sep!=' ') str[j]= ' '; 
		    else str[j]= '\t';
		    }
		  j++;
		  }
		if(j<n) str[j]='\0';
    		}
	return(i);
}

//----------------------------------------------------------------
//Routines pour la lecture des variables et des paramtres

//dtecte le nombre d'x
int lire_x_nb(char* s) {
  if(s==NULL) return(-1);  
  int n=strlen(s);
  if(n<=0) return(-1);
  int i,j;
  for(i=0,j=0;i<n;i++) {
    if(s[i]=='=') j++;                          //variable standard
    if(s[i]=='[') {                             //vecteur
      while(s[i]<'0' || s[i]>'9') {i++; if(i==n) return(-1);}
      int k = atoi(&(s[i])); //lecture de la la premire valeur numrique
      
      while(s[i]!=':' && s[i]!=']') {i++; if(i==n) return(-1);}      
      switch(s[i]) {
        case ':': { //lecture de la la deuxime valeur numrique
          while(i<n && s[i]<'0' || s[i]>'9') i++;
	  if(i==n) return(-1);
	  int l = atoi(&(s[i]));
	  j+=abs(l-k)+1;
	  break;
	  }
	case ']': { //la premire valeur numrique est la taille du vecteur
          j+=k;
	  break;
	  }	  
        }
      while(i<n && s[i]!='=') i++;
      if(i==n) return(-1);
      }
    }
  return(j);
  }

//lit le nom dans une squence x_nom=x    
//renvoit la taille de la variable dtecte
int lire_x_nom(char* s,char* nom_tmp,int* nmin,int* nmax) {
  if(s==NULL) return(-1);  
  int n=strlen(s);
  if(n<=0) return(-1);
  int i = 0;
  *nmin = 1; //index min pour la variable
  *nmax = 1; //index max pour la variable
  while(i<n && (s[i]==' ' && s[i]=='\t')) i++;
  while(i<n && s[i]!='\t' && s[i]!=' ' && s[i]!='=' && s[i]!='[') {
    nom_tmp[i]=s[i]; i++;    
    }
  nom_tmp[i]='\0';
  if(i==n) {
      fprintf(FICHIER_SORTIE,"ERREUR lire_x_nom - pas de valeur dtecte pour %s.\n",nom_tmp);
      return(-1);
      }
  while(i<n && s[i]!='=' && s[i]!='[') {
    i++;     
    if(i==n || (s[i]!=' ' && s[i]!='\t' && s[i]!='=' && s[i]!='[')) {
      fprintf(FICHIER_SORTIE,"ERREUR lire_x_nom - [ ou = manquant aprs %s.\n",nom_tmp);
      return(-1);
      }
    }
  
  if(i<n && s[i]=='[') {      //vecteur
    while(i<n && (s[i]<'0' || s[i]>'9')) i++;          
    if(i<n) (*nmin)=atoi(&(s[i]));   //taille du vecteur
    else {
        fprintf(FICHIER_SORTIE,"ERREUR lire_x_nom - taille du vecteur %s non dfinie\n",nom_tmp);
	return(-1);
	}
    while(i<n && s[i]!=':' && s[i]!=']') i++;
    
    if(i==n) {
        fprintf(FICHIER_SORTIE,"ERREUR lire_x - : ou ] manquant aprs %s[%d.\n",nom_tmp,*nmin);
        return(-1);
        }
    else {
      switch(s[i]) {
        case ':':{
	  while(i<n && (s[i]<'0' || s[i]>'9')) i++;                
          if(i<n) (*nmax)=atoi(&(s[i]));   //taille du vecteur
          else {
            fprintf(FICHIER_SORTIE,"ERREUR lire_x_nom - valeur numrique manquante aprs %s[%d:\n",nom_tmp,*nmin);
	    return(-1);
	    }
	  break;
	  }
	case ']':{
	  *nmax = *nmin;
	  *nmin = 1;
	  break;
	  }
        }      
      }
    }
    
  //on va au = suivant
  while(i<n && s[i]!='=') {
      i++; 
      if(i==n) {
        fprintf(FICHIER_SORTIE,"ERREUR lire_x - = manquant aprs %s.\n",nom_tmp);
        return(-1);
        }
      } 
  return(i);
  }
  
//lit une squence x_nom=x    
//x a une valeur numrique
int lire_x(char* s,int* pos,int nb,char** nom,double* x) {  
  if(s==NULL) return(-1);  
  int n=strlen(s);
  if(n<=0) return(-1);   
  
  char* nom_tmp = (char*) malloc((n+1)*sizeof(char));
  char* nom_tmp2 = (char*) malloc((n+1)*sizeof(char));
  
  //lecture de la chaine
  
  //lecture du nom
  int nmin = 1;
  int nmax = 1;
  int i = lire_x_nom(s,nom_tmp,&nmin,&nmax);
  if(i==-1) return(-1); 
            
  //lecture des valeurs numriques
  double z;
  int test = -1;
  //on va jusqu'au premier chiffre
  while(i<n && (s[i]<'0' || s[i]>'9')) i++;
  
  for(int k=nmin;k<=nmax;k++) {    
    if(i<n && s[i]>='0' && s[i]<='9') {      //lecture de la valeur numrique
      z = atof(&(s[i]));
      
      while(i<n && s[i]!=' ' && s[i]!='\t')   i++; //on va  l'espace suivant
      while(i<n && (s[i]==' ' || s[i]=='\t')) i++; //on passe les espaces
      
      test = 1;
      }
    
    if(test==-1) return(-1);    
       
    if(nmax>nmin) sprintf(nom_tmp2,"%s[%d]",nom_tmp,k);
    else         sprintf(nom_tmp2,"%s",nom_tmp,k+1);    
    if(*pos<nb) {
      nom[*pos] = (char*) malloc((strlen(nom_tmp2)+1)*sizeof(char));    
      sprintf(nom[*pos],"%s",nom_tmp2);    
      x[*pos] = z;
      }    
    *pos += 1;    
    }
      
  free(nom_tmp);
  free(nom_tmp2);
  return(i-1);
  }
  
//lit une squence x_nom=x    
//x est une fonction ; la chaine de caractre correspondante st stocke dans x[*pos]
int lire_x(char* s,int* pos,int nb,char** nom,char** x) {  
  if(s==NULL) return(-1);  
  int n=strlen(s);
  if(n<=0) return(-1);
  
  char* nom_tmp = (char*) malloc((n+1)*sizeof(char));
  char* nom_tmp2 = (char*) malloc((n+1)*sizeof(char));
  char* buf     = (char*) malloc((n+1)*sizeof(char));
    
  //lecture du nom
  int nmin = 1;
  int nmax = 1;
  int i = lire_x_nom(s,nom_tmp,&nmin,&nmax);  
    
  //lecture des quations      
  int test = -1;
  i++; //on passe  droite du '='  
  while(i<n && (s[i]==' ' || s[i]=='\t')) i++; //on va jusqu'au premier caractre
    
  for(int k=nmin;k<=nmax;k++) {            
    if(i<n && s[i]!=' ' && s[i]!='\t' && s[i]!='=') { //lecture de la valeur numrique      
      int j=i;
      while(j<n && s[j]!=' ' && s[j]!='\t')   j++; //on va  l'espace suivant
      int k=j;
      while(k<n && (s[k]==' ' || s[k]=='\t')) k++; //on passe les espaces
      if(s[k]!='=') { 
        //la chaine de caractre qui vient d'tre lue n'est pas suivie d'un '='
	//ce n'est donc pas une dclaration de variable     
        s[j]='\0'; 
        strcpy(buf,&(s[i]));
        test = 1;
        }
      i=k;
      }
    
    if(test==-1) return(-1);        
    if(nmax>nmin) sprintf(nom_tmp2,"%s[%d]",nom_tmp,k);
    else         sprintf(nom_tmp2,"%s",nom_tmp);
    
    if(*pos<nb) {
      nom[*pos] = (char*) malloc((strlen(nom_tmp2)+1)*sizeof(char));    
      sprintf(nom[*pos],"%s",nom_tmp2);
      x[*pos] = (char*) malloc((strlen(buf)+1)*sizeof(char));
      strcpy(x[*pos],buf);    
      }
      
    *pos += 1;    
    }
      
  free(nom_tmp2); free(nom_tmp); free(buf);
  return(i-1);
  }

//lit une squence entire
//les x ont des valeurs numriques  
int lire_seq_x(char* s,int x_nb,char*** x_nom,double** x) {
  if(s==NULL) return(-1);  
  int n=strlen(s);
  if(n<=0) return(-1);
  
  char    *nom;
  int     i,j,test;  
    
  *x_nom = (char**)  malloc(x_nb*sizeof(char*));
  *x     = (double*) malloc(x_nb*sizeof(double));
    
  nom = (char*) malloc((n+1)*sizeof(char));
    
  for(i=0,j=0;i<n && j<x_nb;i++) {        
    //lecture d'une squence x_nom=x
    test = lire_x(&(s[i]),&j,x_nb,*x_nom,*x);
    if(test==-1) return(-1);        
    i+=test;    
  };
  free(nom);  
  return(j);
  };

//lit une squence entire
//les x sont des fonctions  
int lire_seq_x(char* s,int x_nb,char*** x_nom,char*** x_f,double** x) {
  if(s==NULL) return(-1);  
  int n=strlen(s);
  if(n<=0) return(-1);
  
  char    *nom;
  int     i,j,test;  
  
  *x_nom = (char**) malloc(x_nb*sizeof(char*));
  *x_f   = (char**) malloc(x_nb*sizeof(char*));
  *x     = (double*) malloc(x_nb*sizeof(double));
      
  nom = (char*) malloc((n+1)*sizeof(char));
    
  for(i=0,j=0;i<n && j<x_nb;i++) {        
    //lecture d'une squence x_nom=x
    test = lire_x(&(s[i]),&j,x_nb,*x_nom,*x_f);    
    if(test==-1) return(-1);        
    i+=test;    
  };
  
  for(i=0;i<x_nb;i++) (*x)[i] = 0.0;
  
  free(nom);  
  return(j);
  };