/***************************************************************************
                          qmodel.h  -  description
                             -------------------
    begin                : mar avr 6 2004
    copyright            : (C) 2004 by Ferdy Jean-Baptiste
    email                : ferdy@univ-montp2.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef QMODELE_H
#define QMODELE_H

#include "model.h"
#include "coordonnees.h"

#include <qwidget.h>
#include <qtable.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <qnamespace.h>
#include <qcolor.h>




class qmodele : public modele {
  public:
    qmodele(char* texte);
    qmodele(FILE* fichier);
    ~qmodele();
    
    int set_q_var(QTable* tvar);
    int set_q_par(QTable* tpar);
    int set_q_var_par(QTable* tvar,QTable* tpar);

    void get_q_var(QTable* tvar);
    void get_q_par(QTable* tpar);
    void get_q_var_par(QTable* tvar,QTable* tpar);

    void ajout_trajectoire(QTable* tvar,QTable* tpar,double tmax);
    void rafraichir_trajectoire(QTable* tpar,double tmax);
    
    //routines de dessin
    void initialise_pict(); 
        
    void dessine_trajectoire_standard();            
    void dessine_trajectoire_phase();    
    void dessine_trajectoire_finetti();
    void dessine_trajectoire_periode(int periode,int delai);
    //void efface_trajectoire();
        
    coordonnees* coord_standard;
    coordonnees* coord_phase;
    coordonnees* coord_periode;
    coordonnees* coord_finetti;
    
    QPixmap* pict;
  
  };
  
#endif

  
