/***************************************************************************
 *   Copyright (C) 2005 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
 #include "distribution.h"
 
 class sfonction : public fonction {
	public: 
		sfonction(char* sv,char* sp,char** sf); 
		sfonction(int l_nb,int l_var_nb,int l_par_nb,char** var_nom,char** par_nom,double* var,double* par,char** s);
		virtual ~sfonction();

		void ecrire();
		void ecrire(char** nom);
		
		int  stochastique() {if(var_stochastique==1 || par_stochastique==1) return(1); return(0);};
		int  get_var_stochastique() {return(var_stochastique);}
		int  get_par_stochastique() {return(par_stochastique);}
		
		void set_var_dist(distribution** d);
		void set_par_dist(distribution** d);
		
		void set_var_stochastique(int i);
		void set_par_stochastique(int i);		
		
		distribution** get_var_dist() {return(var_dist);};
		distribution** get_par_dist() {return(par_dist);};
		distribution*  get_var_dist(int i) {if(i>-1&&i<var_nb) return(var_dist[i]); return(NULL);};
		distribution*  get_par_dist(int i) {if(i>-1&&i<par_nb) return(par_dist[i]); return(NULL);};
		
		int      eval(double* x,double* y);   //valuation standard
		int      eval(double* x);  
		int      meval(double* x,double* y);  //valuation produit matriciel
		int      meval(double* x);

	private:
		int var_stochastique;
		distribution** var_dist;
		int par_stochastique;
		distribution** par_dist;
		
		double* par_tmp_1; //vecteurs temporaires utiliss dans l'valuation
		double* par_tmp_2;
		double* var_tmp;
		double* x_tmp;
	};
