/***************************************************************************
 *   Copyright (C) 2005 by Jean-Baptiste Ferdy                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
 #include "specification_distribution.h"
 
 #define  NB_DIST 14
  
 extern FILE*  FICHIER_SORTIE;
 extern char   MSG_PROBLEME_CALCUL[];
 
 
 
 char           SPEC_DIST_NOM[NB_DIST][25];
 char           SPEC_DIST_TYPE[NB_DIST];
 unsigned int   SPEC_DIST_SYMB[NB_DIST];
 unsigned int   SPEC_DIST_NMIN[NB_DIST];
 unsigned int   SPEC_DIST_NMAX[NB_DIST]; 
 func_pt        SPEC_DIST_C[NB_DIST];
 func_pt        SPEC_DIST_F[NB_DIST];
 
 //********************************************************************************************************
 //routines d'valuation
 //********************************************************************************************************
 //lois discrtes   
   //distribution teste : OK
   func_pt construction_uniformed = NULL;
   
   //distribution teste : OK
   double construction_poisson (int n,double* x,int* test) {
     if(n!=1) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_poisson - impossible de dfinir une poisson avec %d argument(s)\n",n);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     //paramtres et moments sont identiques
     return(0.0);
     };
      
   //distribution teste : constructinon par paramtre  OK
   //                      construction par les moments OK 
   double construction_bernouilli (int n,double* x,int* test) {
     if(n!=1) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_bernouilli - impossible de dfinir une bernouilli avec %d argument(s)\n",n);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     //paramtres et moments sont identiques
     return(0.0);
     };
   
   //distribution teste : OK
   func_pt construction_bernoulli_multiple = NULL;
      
   //distribution teste : constructinon par paramtre  OK
   //                      construction par les moments OK                 
   double construction_binomiale (int n,double* x,int* test) {
     if(n!=2) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_binomiale - impossible de dfinir une binomiale avec %d argument(s)\n",n);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     double moy = x[0];
     double var = x[1];          
     if(moy==0) {x[0] = 0.0; x[1] = 1.0; return(0.0);}     
     if(var==0) {x[0] = 1.0; x[1] = moy; return(0.0);}  
     if(var>=moy || moy<=0 || var<=0) {       
       MSG_PROBLEME_CALCUL[0]='\0';
       if(moy<0)    sprintf(MSG_PROBLEME_CALCUL,"%sERREUR construction_binomiale - la moyenne d'une binomiale ne peut tre ngative\n",MSG_PROBLEME_CALCUL);
       if(var<=0)   sprintf(MSG_PROBLEME_CALCUL,"%sERREUR construction_binomiale - la variance d'une binomiale ne peut tre ngative\n",MSG_PROBLEME_CALCUL);
       if(var>=moy) sprintf(MSG_PROBLEME_CALCUL,"%sERREUR construction_binomiale - la variance d'une binomiale ne peut tre suprieure ou gale  sa moyenne\n",MSG_PROBLEME_CALCUL);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }         
     x[0] = 1-var/moy; x[1] = moy/x[0];  return(0.0);
     };        
   
   //distribution teste : OK
   func_pt construction_hypergeometrique = NULL;
   
   //distribution teste : constructinon par paramtre  OK
   //                      construction par les moments OK
   double construction_binomiale_negative (int n,double* x,int* test) {
     if(n!=2) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_binomiale_negative - impossible de dfinir une binomiale negative avec %d argument(s)\n",n);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     if(x[1]<=x[0] || x[0]<=0 || x[1]<=0) {       
       MSG_PROBLEME_CALCUL[0]='\0';
       if(x[0]<0)    sprintf(MSG_PROBLEME_CALCUL,"%sERREUR construction_binomiale_negative - la moyenne d'une binomiale negative ne peut tre ngative\n",MSG_PROBLEME_CALCUL);
       if(x[1]<=0)   sprintf(MSG_PROBLEME_CALCUL,"%sERREUR construction_binomiale_negative - la variance d'une binomiale negative ne peut tre ngative\n",MSG_PROBLEME_CALCUL);
       if(x[1]<=x[0]) sprintf(MSG_PROBLEME_CALCUL,"%sERREUR construction_binomiale_negative - la variance d'une binomiale negative ne peut tre infrieure ou gale  sa moyenne\n",MSG_PROBLEME_CALCUL);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     double p = x[0]/x[1];
     double k = x[0]*p/(1-p);
     x[0] = p;
     x[1] = k;
     return(0.0);
     };
   
   //distribution teste : constructinon par paramtre  OK
   //                      construction par les moments OK   
   double construction_geometrique (int n,double* x,int* test) {
     if(n!=1) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_geometrique - impossible de dfinir une gomtrique avec %d argument(s)\n",n);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     if(x[0]<0) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_geometrique - la moyenne d'une distribution gomtrique doit tre positive.\n");
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     x[0] = 1.0/(1.0+x[0]);
     return(0.0);
     };
  
 //lois continues  
   //distribution teste : OK
   func_pt construction_uniformec = NULL;
   
   //distribution teste : constructinon par paramtre  OK
   //                      construction par les moments OK                 
   double construction_normale (int n,double* x,int* test) {     
     if(n!=2) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_normale - impossible de dfinir une normale avec %d argument(s)\n",n);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     double moy = x[0];
     if(x[1]<=0) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_normale - la variance d'une normale ne peut tre ngative\n");
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       } 
     x[1] = pow(x[1],0.5); 
     return(0.0);
     };
     
   //distribution teste : constructinon par paramtre OK
   //                      construction par les moments OK  
   double construction_lognormale (int n,double* x,int* test) {                
     if(n!=2) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_lognormale - impossible de dfinir une log-normale avec %d argument(s)\n",n);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     if(x[0]<=0) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_lognormale - la moyenne d'une log-normale ne peut tre ngative\n");
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     if(x[1]<=0) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_lognormale - la variance d'une log-normale ne peut tre ngative\n");
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }     
     double var = log(x[1]/pow(x[0],2.0)+1);
     double moy = log(x[0])-var/2.0;
     x[0] = moy;
     x[1] = pow(var,0.5);
     return(0.0);
     };
      
   //distribution teste : constructinon par paramtre OK
   //                      construction par les moments 0K     
   double construction_exponentielle (int n,double* x,int* test) {    
     if(n!=1) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_exponentielle - impossible de dfinir une exponentielle avec %d argument(s)\n",n);
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }
     //les paramtres sont les moments 
     return(0.0);
     };
     
   //distribution teste : constructinon par paramtre OK
   //                      construction par les moments 0K  
   double construction_gamma (int n,double* x,int* test) {
     if(n!=2) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_gamma - impossible de dfinir une gamma avec %d argument(s)\n",n);
     fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       } 
     if(x[1]<=0) {
       sprintf(MSG_PROBLEME_CALCUL,"ERREUR construction_lognormale - la variance d'une gamma ne peut tre ngative\n");
       fprintf(FICHIER_SORTIE,"%s",MSG_PROBLEME_CALCUL);
       *test = -1;
       return(0.0);
       }       
     double s = x[1]/x[0];
     double a = x[0]/s;
     x[0] = a;
     x[1] = s;
     return(0.0);
     };
  //distribution teste : OK   
  func_pt  construction_beta  = NULL;
 
 //**ROUTINES DE BASE
  int  ajout_specification_distribution(int pos,char* nom,char type,char symb,int nmin,int nmax,char* nom_f_eval,func_pt func_constr) {
   if(pos<0 || pos>NB_DIST) {printf("ERREUR ajout_specification_distribution - position incorrecte !\n"); exit(-1);}
   
   strcpy(SPEC_DIST_NOM[pos],nom);
   SPEC_DIST_TYPE[pos] = type; 
   SPEC_DIST_SYMB[pos] = symb; 
   SPEC_DIST_NMIN[pos] = nmin; 
   SPEC_DIST_NMAX[pos] = nmax;
   SPEC_DIST_F[pos]    = get_fonction_evaluation(symbole_fonction(nom_f_eval));
   SPEC_DIST_C[pos]    = func_constr;
   return(1);
   }
   
 void charge_specification_distribution() {
   
   //lois discrtes
   ajout_specification_distribution(0,(char*)"uniforme discrete",'d','a',0,2,(char*)"runiformed",construction_uniformed);
   ajout_specification_distribution(1,(char*)"poisson",'d','b',1,1,(char*)"rpoisson",construction_poisson);
   ajout_specification_distribution(2,(char*)"bernoulli",'d','c',1,1,(char*)"rbernoulli",construction_bernouilli);
   ajout_specification_distribution(3,(char*)"discrete generale",'d','d',1,-1,(char*)"rdiscrete",construction_bernoulli_multiple);
   ajout_specification_distribution(4,(char*)"binomiale",'d','e',2,2,(char*)"rbinomiale",construction_binomiale);   
   ajout_specification_distribution(5,(char*)"hypergeometrique",'d','g',3,3,(char*)"rhypergeo",construction_hypergeometrique);   
   ajout_specification_distribution(6,(char*)"binomiale negative",'d','i',2,2,(char*)"rbinomialeneg",construction_binomiale_negative);   
   ajout_specification_distribution(7,(char*)"geometrique",'d','k',1,1,(char*)"rgeometrique",construction_geometrique); 
  
   //lois continues
   ajout_specification_distribution(8,(char*)"uniforme continue",'c','1',0,2,(char*)"runiformec",construction_uniformec);
   ajout_specification_distribution(9,(char*)"normale",'c','2',2,2,(char*)"rnormale",construction_normale);
   ajout_specification_distribution(10,(char*)"lognormale",'c','3',2,2,(char*)"rlognormale",construction_lognormale);   
   ajout_specification_distribution(11,(char*)"exponentielle",'c','5',1,1,(char*)"rexponentielle",construction_exponentielle);
   ajout_specification_distribution(12,(char*)"gamma",'c','6',2,2,(char*)"rgamma",construction_gamma);
   ajout_specification_distribution(13,(char*)"beta",'c','7',2,2,(char*)"rbeta",construction_beta); 
    
   }
   
   
    //****************************************************
 //routines de base
 //****************************************************
 char symbole_distribution(char* nom){
   unsigned int i =0;
   while(i<NB_DIST && strcmp(SPEC_DIST_NOM[i],nom)!=0) i++;
   if(strcmp(SPEC_DIST_NOM[i],nom)==0) return(SPEC_DIST_SYMB[i]);
   return('?');
   };
   
 char* nom_distribution(char c) {
   unsigned int i = (unsigned int) 0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!= (unsigned int) c) i++;
   if(SPEC_DIST_SYMB[i]== (unsigned int) c) return(SPEC_DIST_NOM[i]);
   return(NULL);
   };
 
 char* nom_distribution(int i) {
   if(i<0 || i>=NB_DIST) return(NULL);
   return(SPEC_DIST_NOM[i]);
   };
       
 char type_distribution(char* nom){
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && strcmp(SPEC_DIST_NOM[i],nom)!=0) i++;
   if(strcmp(SPEC_DIST_NOM[i],nom)==0) return(SPEC_DIST_TYPE[i]);
   return('?');
   };
 
 char type_distribution(char  c) {
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!=(unsigned int) c) i++;
   if(SPEC_DIST_SYMB[i]==(unsigned int) c) return(SPEC_DIST_TYPE[i]);
   return('?');
   };
 
 char type_distribution(int   i) {
   if(i<NB_DIST) return(SPEC_DIST_TYPE[i]);
   return('?');
   }
 
 int nb_arg_min_distribution(char* nom){
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && strcmp(SPEC_DIST_NOM[i],nom)!=0) i++;
   if(strcmp(SPEC_DIST_NOM[i],nom)==(unsigned int) 0) return(SPEC_DIST_NMIN[i]);
   return(-1);
   };
 int nb_arg_min_distribution(char  c){
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!=(unsigned int) c) i++;
   if(SPEC_DIST_SYMB[i]==(unsigned int) c) return(SPEC_DIST_NMIN[i]);
   return(-1);
   };
 int nb_arg_min_distribution(int   i){
   if(i<NB_DIST) return(SPEC_DIST_NMIN[i]);
   return(-1);
   };
 
 int nb_arg_max_distribution(char* nom){
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && strcmp(SPEC_DIST_NOM[i],nom)!=(unsigned int) 0) i++;
   if(strcmp(SPEC_DIST_NOM[i],nom)==(unsigned int) 0) return(SPEC_DIST_NMAX[i]);
   return(-1);
   };
 int nb_arg_max_distribution(char  c){
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!=(unsigned int) c) i++;
   if(SPEC_DIST_SYMB[i]==(unsigned int) c) return(SPEC_DIST_NMAX[i]);
   return(-1);
   };
 int nb_arg_max_distribution(int i){
   if(i<NB_DIST) return(SPEC_DIST_NMAX[i]);
   return(-1);
   };
 
 int nb_arg_correct_distribution(char* nom,int n){
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && strcmp(SPEC_DIST_NOM[i],nom)!=0) i++;
   if(strcmp(SPEC_DIST_NOM[i],nom)==0 && i<NB_DIST) {
     if((unsigned int) n>=SPEC_DIST_NMIN[i] && (unsigned int) n <=SPEC_DIST_NMAX[i]) return(1);
     else return(0);
     }
   return(-1);
   };
   
 int nb_arg_correct_distribution(char  c,int n){
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!=(unsigned int)  c) i++;
   if(SPEC_DIST_SYMB[i]==(unsigned int) c && i<NB_DIST) {
     if((unsigned int) n>=SPEC_DIST_NMIN[i] &&(unsigned int) n <=SPEC_DIST_NMAX[i]) return(1);
     else return(0);
     }
   return(-1);
   };
 int nb_arg_correct_distribution(int i,int n){
   if(i<NB_DIST) {
     if((unsigned int) n>=SPEC_DIST_NMIN[i] &&(unsigned int) n <=SPEC_DIST_NMAX[i]) return(1);
     else return(0);
     }
   return(-1);
   };
 
 func_pt get_fonction_evaluation_distribution(char c) {
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!=(unsigned int) c) i++;
   if(SPEC_DIST_SYMB[i]==(unsigned int) c && i<NB_DIST) {
     return(SPEC_DIST_F[i]);      
     }
   return(NULL);
 }
     
 int set_fonction_evaluation_distribution(double (*f)(int,double*,int*),char* nom) {
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && strcmp(SPEC_DIST_NOM[i],nom)!=0) i++;
   if(strcmp(SPEC_DIST_NOM[i],nom)==0 && i<NB_DIST) {
     f = SPEC_DIST_F[i]; 
     return(1);
     }
   return(-1);
 }
 int set_fonction_evaluation_distribution(double (*f)(int,double*,int*),char c) {
   unsigned int i =(unsigned int) 0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!=(unsigned int) c) i++;
   if(SPEC_DIST_SYMB[i]==(unsigned int) c && i<NB_DIST) {
     f = SPEC_DIST_F[i]; 
     return(1);
     }
   return(-1);
 }
 int fonction_evaluation_distribution(double (*f)(int,double*,int*),int i) {
   if(i<NB_DIST) {f = SPEC_DIST_F[i]; return(1);}
   return(-1);
   }
   
 int set_fonction_construction_distribution(double (*f)(int,double*,int*),char* nom) {
   unsigned int i =0;
   while(i<NB_DIST && strcmp(SPEC_DIST_NOM[i],nom)!=0) i++;
   if(strcmp(SPEC_DIST_NOM[i],nom)==0 && i<NB_DIST) {
     f = SPEC_DIST_C[i]; 
     return(1);
     }
   return(-1);
 }
 int set_fonction_construction_distribution(double (*f)(int,double*,int*),char c) {
   unsigned int i =0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!=(unsigned int) c) i++;
   if(SPEC_DIST_SYMB[i]==(unsigned int) c && i<NB_DIST) {
     f = SPEC_DIST_C[i]; 
     return(1);
     }
   return(-1);
 }
 int fonction_construction_distribution(double (*f)(int,double*,int*),int i) {
   if(i<NB_DIST) {f = SPEC_DIST_C[i]; return(1);}
   return(-1);
   }      

func_pt get_fonction_construction_distribution(char c) {
   unsigned int i =0;
   while(i<NB_DIST && SPEC_DIST_SYMB[i]!=(unsigned int) c) i++;
   if(SPEC_DIST_SYMB[i]==(unsigned int) c && i<NB_DIST) {
     return(SPEC_DIST_C[i]);      
     }
   return(NULL);
 }
