/***************************************************************************
 *   Copyright (C) 2004 by Ferdy Jean-Baptiste                             *
 *   ferdy@univ-montp2.fr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "supprimer_une_trajectoire.h"
#include "form_supprimer_une_trajectoire.h"

#include <qspinbox.h>
#include <qlabel.h>
#include <qpushbutton.h>

supprimer_une_trajectoire::supprimer_une_trajectoire(qmodele* xm) : Form_supprimer_une_trajectoire()
{
QObject::connect(pushButton_ok,SIGNAL(clicked()),this,SLOT(ok()));
QObject::connect(pushButton_annuler,SIGNAL(clicked()),this,SLOT(annuler()));
QObject::connect(pushButton_apercu,SIGNAL(clicked()),this,SLOT(apercu()));
QObject::connect(spinBox_n1,SIGNAL(valueChanged(int)),this,SLOT(change_n1()));
m=xm;

int i = m->get_tr_nb();
if(i) {spinBox_n1->setMinValue(1); spinBox_n2->setMinValue(1);}
else               {spinBox_n1->setMinValue(0); spinBox_n2->setMinValue(0);}


spinBox_n1->setMaxValue(i);
spinBox_n2->setMaxValue(i);
QString buf;
buf.sprintf("%d trajectoire(s) charge(s)",i);
textLabel_n->setText(buf);
}

void supprimer_une_trajectoire::change_n1() {
	int i = spinBox_n1->value();
	if(spinBox_n2->value()<i) spinBox_n2->setValue(i);
	spinBox_n2->setMinValue(i);
	}

void supprimer_une_trajectoire::ok() {
int i = spinBox_n1->value();
if(i==0) return;
int j = spinBox_n2->value();
if(j<i) return;

for(int k=i-1;k<=j-1;k++)
	m->suppr_trajectoire(i-1);

i = m->get_tr_nb();
spinBox_n1->setMaxValue(i);
spinBox_n2->setMaxValue(i);
QString buf;
buf.sprintf("%d trajectoire(s) charge(s)",i);
textLabel_n->setText(buf);

accept();
}

void supprimer_une_trajectoire::annuler() {
for(int i=0;i<m->get_tr_nb();i++) m->get_trajectoire(i)->reset_style();
reject();
}

void supprimer_une_trajectoire::apercu() {
for(int i=0;i<m->get_tr_nb();i++) m->get_trajectoire(i)->reset_style();

int i = spinBox_n1->value();
if(i==0) return;
int j = spinBox_n2->value();
if(j<i) return;

for(int k=i-1;k<=j-1;k++) m->get_trajectoire(k)->set_style(2);

accept();
}

//#include "supprimer_une_trajectoire.moc"

