/***************************************************************************
                          trajectoire.h  -  description
                             -------------------
    begin                : dim fv 29 2004
    copyright            : (C) 2004 by Ferdy Jean-Baptiste
    email                : ferdy@univ-montp2.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <gsl/gsl_histogram.h>

class trajectoire {
   public:
    trajectoire(int l_var_nb,int l_pt_nb,double** l_v);
    ~trajectoire();

    void     set_v(double** vv) {v=vv;};
    void     set_pt_nb(int k) {pt_nb=k;};
    void     set_style(int k) {_style=k;};
    void     reset_style() {_style=0;}

    double** get_v() {return(v);};
    int      get_pt_nb() {return(pt_nb);};
    double   get_tmax();
    void     get_ini(double* x);
    double   get_xmax();
    double   get_xmax(int j);
    double   get_xmin();
    double   get_xmin(int j);

    int      style() {return(_style);}

    void     ecrire();
    void     ecrire(FILE* fichier);
    void     ecrire(FILE* fichier,int i,char c);
    void     ecrire_sans_t();
    void     ecrire_sans_t(FILE* fichier);
    void     ecrire_sans_t(FILE* fichier,int i,char c);

    gsl_histogram*  histograme(double t1,double t2,int var_pos,int nb_classe);

   private:
    int      var_nb;
    int      pt_nb;
    int      _style;
    double** v;
   };

//fin
