/***************************************************************************
                          xml.cpp  -  description
                             -------------------
    begin                : dim fv 29 2004
    copyright            : (C) 2004 by Ferdy Jean-Baptiste
    email                : ferdy@univ-montp2.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "xml.h"

//#define OBJET_MAX_CHAR 250

extern FILE* FICHIER_SORTIE;

int MAXCHARXML=5000;

int longueur_chaine(char* s) { 
  if(s==NULL || sizeof(s)==0) return(0);
  return(strlen(s));
  }
  
int lire_texte(char* nom,char** texte) {
  FILE* fichier;
  fichier = fopen(nom,"r");
  if(fichier==NULL) {
    fprintf(FICHIER_SORTIE,"ERREUR lire_texte - impossible de lire dans %s\n",nom);
    return(-1);
    }

  int i=0; char c;
  while(fscanf(fichier,"%c",&c)==1 && i<MAXCHARXML) {
    *texte = (char*) realloc(*texte,(i+1)*sizeof(char));
    (*texte)[i] = c;
    i++;
    }          
  fclose(fichier);
  return(i);
  }

int lire_texte(FILE* fichier,char** texte) { 
  if(fichier==NULL) {
    fprintf(FICHIER_SORTIE,"ERREUR lire_texte - fichier inaccessible.\n");
    return(-1);
    }
  
  *texte = (char*) malloc(sizeof(char));
  
  int i=0; char c;
  while(fscanf(fichier,"%c",&c)==1 && i<MAXCHARXML) {
    *texte = (char*) realloc(*texte,(i+1)*sizeof(char));
    (*texte)[i] = c;
    i++;
    }
    
  *texte = (char*) realloc(*texte,(i+1)*sizeof(char));
  (*texte)[i] = '\0';
  fclose(fichier);
  return(i);
  }


	    
//cherche la premire occurrence de bal dans texte  
int cherche_balise(char* texte,char* bal){
  int i,j,n,n_bal;
  if(texte==NULL || bal==NULL) {fprintf(FICHIER_SORTIE,"ERREUR cherche_balise - texte ou balise invalide\n"); return(-1);}
  n=longueur_chaine(texte);    //longueur du texte
  n_bal=longueur_chaine(bal);  //longueur de la balise
  i=0;
  while(i<n) {
    if(texte[i]=='<') {
      i++; j=0;
      if(i+2<n && texte[i]=='!' && texte[i+1]=='-' && texte[i+2]=='-') { //commentaire
        while(i+2<n && (texte[i]!='-' || texte[i+1]!='-' || texte[i+2]!='>')) i++;
        }
      else {
        while(j<n_bal && i+j<n && texte[i+j]==bal[j]) j++;      
        i+=j;
        if(i<n && j==n_bal && texte[i]=='>') {i++; return(i);}
      }
      }
    i++;
    }    
  return(-1);
  }

//cherche la premire occurrence de bal dans texte; place les tiquettes associe  la balise dans tag  
//renvoit la position du > fermant la balise
int cherche_balise(char* texte,char* bal,char** tag){
  int i,j,n,n_bal;
  *tag = NULL;
  
  if(texte==NULL || bal==NULL) {fprintf(FICHIER_SORTIE,"ERREUR cherche_balise - texte ou balise invalide\n"); return(-1);}
  n=longueur_chaine(texte);    //longueur du texte
  n_bal=longueur_chaine(bal);  //longueur de la balise
  
  i=0;
  while(i<n) {
    if(texte[i]=='<') {
      i++; j=0;
      if(i+2<n && texte[i]=='!' && texte[i+1]=='-' && texte[i+2]=='-') { //la balise est un commentaire
        while(i+2<n && (texte[i]!='-' || texte[i+1]!='-' || texte[i+2]!='>')) i++;
        }
      else {
        while(j<n_bal && i+j<n && texte[i+j]==bal[j]) j++;
        i+=j;
        if(i<n && j==n_bal) {
          if(texte[i]=='>') {
	    *tag = (char*) malloc(sizeof(char));
	    (*tag)[0]='\0';
            i++;
            return(i);
            }
          i++; j=0;
	  *tag = (char*) malloc(sizeof(char));
          while(i+j<n && texte[i+j]!='>') {
            (*tag)[j]=texte[i+j];
            j++;
	    *tag = (char*) realloc(*tag,(j+1)*sizeof(char));
            }
          (*tag)[j]='\0';
          i+=j+1;
          return(i);
          }
        }
      }
    i++;
    }
  return(-1);
  }  
  
//cherche la premire occurrence de bal dans texte et renvoit une chaine de caractre contenant la valeur de la balise
char* lire_balise_obl(char* texte,char* bal){
  char* buf;
  int n=longueur_chaine(bal);
  if(n<1) return(NULL);
  buf=(char*)malloc((n+2)*sizeof(char));  
  buf[0]='/'; for(int i=0;i<n;i++) buf[i+1]=bal[i]; buf[n+1]='\0';

  //sprintf(buf,"/%s",bal);

  int i=cherche_balise(texte,bal); //cherche balise de dbut
  if(i==-1) {
    fprintf(FICHIER_SORTIE,"ERREUR lire_balise - <%s> introuvable\n",bal);
    return(NULL);
    }
  int j=cherche_balise(texte,buf); //cherche balise de fin
  if(j==-1) {
    fprintf(FICHIER_SORTIE,"ERREUR lire_balise - <%s> dtect mais </%s> introuvable\n",bal,bal);
    return(NULL);
    }
  while(texte[i]=='\n' || texte[i]=='\t' || texte[i]==' ' || texte[i]=='\0') i++;

  j-= longueur_chaine(bal)+4;
  free(buf);
  n=j-i+1;
  buf=(char*)malloc((n+1)*sizeof(char));
  for(j=0;j<n;j++) buf[j]=texte[i+j]; buf[n]='\0';
  return(buf);
  }
  
//cherche la premire occurrence de bal dans texte et renvoit une chaine de caractre contenant la valeur de la balise
char* lire_balise(char* texte,char* bal){  
  char* buf;
  int n=longueur_chaine(bal);
  if(n<1) return(NULL);      
  int i=cherche_balise(texte,bal); //cherche balise de dbut
  if(i==-1) return(NULL);    
  
  buf=(char*)malloc((n+2)*sizeof(char));
  buf[0]='/'; for(int i=0;i<n;i++) buf[i+1]=bal[i]; buf[n+1]='\0';  
  int j=cherche_balise(texte,buf); //cherche balise de fin
  if(j==-1) {
    free(buf);
    fprintf(FICHIER_SORTIE,"ERREUR lire_balise - <%s> dtecte mais </%s> introuvable\n",bal,bal);
    return(NULL);
    }
  while(texte[i]=='\n' || texte[i]=='\t' || texte[i]==' ' || texte[i]=='\0') i++;

  j-= longueur_chaine(bal)+4;
  free(buf);
  n=j-i+1;
  buf=(char*)malloc((n+1)*sizeof(char));
  for(j=0;j<n;j++) buf[j]=texte[i+j]; buf[n]='\0';
  return(buf);
  }

//cherche la cmpt occurrence de bal dans texte et renvoit une chaine de caractre contenant la valeur de la balise
char* lire_balise(char* texte,char* bal,int cmpt){
  int   i,j,k,n;
  char* buf;

  for(j=0,i=0;j<=cmpt;j++) {
    k=cherche_balise(&(texte[i]),bal);
    if(k==-1) return(NULL);
    i+=k;
    } //cherche cmpt balises de dbut
  
  n= longueur_chaine(bal);
  if(n<1) return(NULL);
  buf=(char*)malloc((n+2)*sizeof(char));
  buf[0]='/'; for(int i=0;i<n;i++) buf[i+1]=bal[i]; buf[n+1]='\0';
  j=cherche_balise(&(texte[i]),buf);  //cherche balise de fin
  free(buf);
  if(j==-1) {
    fprintf(FICHIER_SORTIE,"ERREUR lire_balise - <%s> dtect mais </%s> introuvable\n",bal,bal);
    return(NULL);
    }
  j+=i;
  while(texte[i]=='\n' || texte[i]=='\t' || texte[i]==' ' || texte[i]=='\0') i++;

  j-= longueur_chaine(bal)+4;
  
  n=j-i+1;
  buf=(char*)malloc((n+1)*sizeof(char));
  for(j=0;j<n;j++) buf[j]=texte[i+j]; buf[n]='\0';
  return(buf);
  }  

//cherche la premire occurrence de bal dans texte, stocke les tiquette dans tag et renvoit une chaine de caractre contenant la valeur de la balise
char* lire_balise(char* texte,char* bal,char** tag){
  char* buf;
  *tag = NULL;
  
  int n= longueur_chaine(bal);  
  
  if(n<1) return(NULL);      
  int i=cherche_balise(texte,bal,tag); if(i==-1) return(NULL); //cherche balise de dbut
  buf=(char*)malloc((n+2)*sizeof(char));
  buf[0]='/'; for(int i=0;i<n;i++) buf[i+1]=bal[i]; buf[n+1]='\0';
  int j=cherche_balise(texte,buf);   //cherche balise de fin
  free(buf);
  if(j==-1) {    
    fprintf(FICHIER_SORTIE,"ERREUR lire_balise - <%s> dtect mais </%s> introuvable\n",bal,bal);
    return(NULL);
    }
  while(texte[i]=='\n' || texte[i]=='\t' || texte[i]==' ' || texte[i]=='\0') i++;

  j-= longueur_chaine(bal)+4;  
  n=j-i+1;
  buf=(char*)malloc((n+1)*sizeof(char));
  for(j=0;j<n;j++) buf[j]=texte[i+j]; buf[n]='\0';
  return(buf);
  }

//cherche la cmpt occurrence de bal dans texte, stocke les tiquettes dans tag et renvoit une chaine de caractre contenant la valeur de la balise
char* lire_balise(char* texte,char* bal,char** tag,int cmpt){
  int   i,j,k,n;
  char* buf;
  *tag = NULL;
  
  for(j=0,i=0;j<=cmpt;j++) {
    k=cherche_balise(&(texte[i]),bal,tag);
    if(k==-1) {
      if((*tag)!=NULL) free(*tag); *tag=NULL;
      return(NULL);
      }
    i+=k;
    } //cherche cmpt balises de dbut

  n= longueur_chaine(bal);
  if(n<1) {
      if((*tag)!=NULL) free(*tag);  *tag=NULL;
      return(NULL);
      }
  buf=(char*)malloc((n+2)*sizeof(char));
  buf[0]='/'; for(int i=0;i<n;i++) buf[i+1]=bal[i]; buf[n+1]='\0';
  
  j=cherche_balise(&(texte[i]),buf);   //cherche balise de fin
  if(j==-1) {    
    fprintf(FICHIER_SORTIE,"ERREUR lire_balise - <%s> dtect mais </%s> introuvable\n",bal,bal);
    if((*tag)!=NULL) free(*tag); *tag=NULL;
    if(buf!=NULL) free(buf);
    return(NULL);
    }
  j+=i;
  while(texte[i]=='\n' || texte[i]=='\t' || texte[i]==' ' || texte[i]=='\0') i++;

  j-= longueur_chaine(bal)+4;
  free(buf);
  n=j-i+1;
  buf=(char*)malloc((n+1)*sizeof(char));
  for(j=0;j<n;j++) buf[j]=texte[i+j]; buf[n]='\0';
  return(buf);
  }

//lecture de la prochaine balise  
//la balise est stocke dans bal, le contenu dans cont et les tag dans tag
//revoit un entier correspondant  la position du caractre suivant le > de fin de la balise fermante
int lire_balise(char* texte,char** bal,char** tag,char** cont){
  int pos=0;
  *tag = NULL;
  //recherche de la balise
  int n = strlen(texte);
  while(texte[pos]!='<' && pos<n) pos++;
  pos++;
  if(pos>=n) return(-1);  
  //lecture de la balise
  int i=0;
  *bal = (char*) malloc(sizeof(char));  
  while(texte[pos]!=' ' && texte[pos]!='>' && pos<n) {
    i++;
    *bal = (char*) realloc(*bal,(i+1)*sizeof(char));
    (*bal)[i-1] = texte[pos];
    (*bal)[i] = '\0';
    if(i==3 && strcmp(*bal,"!--")==0) { //la balise est-elle un commentaire ?
      while(strcmp(*bal,"-->")!=0 && pos<n) {
        pos++;
	(*bal)[0] = (*bal)[1];
	(*bal)[1] = (*bal)[2];
	(*bal)[2] = texte[pos];
	}
      
      *bal = (char*) realloc(*bal,sizeof(char)); 
      //on vide la balise et on recommence  cherche une balise
      }
    pos++;
    }   
  while(pos<n && texte[pos]==' ' || texte[pos]=='\t') pos++; //avance jusqu'au tag  
  if(pos>=n) return(-1);
  
  if(texte[pos]!='>') { //la balise ouvrante est-elle ferme ? Si non...    
    //lecture des tags
    i=0;
    *tag = (char*) malloc(sizeof(char));  
    while(texte[pos]!='>' && pos<n) {
      i++;
      *tag = (char*) realloc(*tag,(i+1)*sizeof(char));
      (*tag)[i-1] = texte[pos];
      (*tag)[i] = '\0';
      pos++;
      }                                     
    }
  else {if(*tag!=NULL) free(*tag); *tag=NULL;} //pas de tag dtect
  
  pos++;                        //se positionne  droite du >
  while(texte[pos]==' ') pos++; //avance jusqu'au prochain charactre non-vide
  if(pos>=n) {
    if(*tag!=NULL) free(*tag);  *tag=NULL;
    return(-1);
    }
      
  //lecture du contenu
  char* buf = (char*) malloc((strlen(*bal)+2)*sizeof(char));
  sprintf(buf,"/%s",*bal);
  i=cherche_balise(&(texte[pos]),buf);   //cherche balise de fin
  
  if(i==-1) {
    fprintf(FICHIER_SORTIE,"ERREUR lire_balise - <%s> dtecte mais <%s> introuvable\n",*bal,buf);
    free(buf);
    if(*tag!=NULL) free(*tag); *tag=NULL;
    return(-1);
    }
  i -= strlen(buf)+2;
  if(i<0) *cont = NULL;
  else {
    *cont = (char*) malloc((i+1)*sizeof(char));
    int j=0;
    while(j+pos<i && (texte[j+pos]==' ' || texte[j+pos]=='\t' || texte[j+pos]=='\n' || texte[j+pos]=='\0')) j++;
    int k=0;
    for(;j+k<i;k++) (*cont)[k] = texte[k+j+pos];
    (*cont)[k] = '\0';
    }
  pos += i+strlen(buf)+2;
  free(buf);
  return(pos);
}
  
//lecture d'une valeur de tag
char* lire_valeur_tag(char* texte,char* tag) {
  int n=strlen(texte);
  int n_tag=strlen(tag);
  int i=0;
  while(i<(n-n_tag)&&strncmp(&(texte[i]),tag,n_tag)!=0) i++;   
  if(i>=n-n_tag) return(NULL);
  i+=n_tag;
  while(i < n && texte[i]!='=') i++;
  if(i==n) return(NULL); //pas de = trouv 
  i++;
  while(i < n && (texte[i]==' ' || texte[i]=='\t')) i++;
  int j;
  char* buf = (char*) malloc((n-i+1)*sizeof(char));
  for(j=0;i<n && texte[i]!=' '&& texte[i]!='\t';j++,i++) buf[j]=texte[i];
  buf[j]='\0';
  return(buf);
  }

